section .text

    global _cpuida   

 _cpuida:

    push eax
    push ebx
    push ecx
    push edx
    push edi

    mov  eax, 1
    CPUID
    mov [eaxCode1], eax  ; Features Code
    mov [edxCode1], edx  ; family/model/stepping
    mov [ebxCode1], ebx
    mov [ecxCode1], ecx

    mov  edi, idString1
    mov  eax, 0
    CPUID
    mov[edi],   ebx
    mov[edi+4], edx
    mov[edi+8], ecx
    mov ecx, 0
    mov[edi+12], ecx
    mov [intel1amd2], ebx


    ; get specials
    mov eax,80000000h
    CPUID
    cmp eax,80000000h
    jc nomore

    mov eax, [intel1amd2]
    cmp eax, 756E6547h    ; uneG
    jz intel
    cmp eax, 68747541h    ; htuA
    jnz nomore
    mov eax,80000001h
    CPUID

    mov [ext81edx], edx

    mov eax,80000000h
    CPUID
    cmp eax,80000004h
    jc nomore                
    mov  edi, idString2
    mov eax,80000002h
    CPUID
    mov[edi],    eax
    mov[edi+4],  ebx
    mov[edi+8],  ecx
    mov[edi+12], edx
    mov eax,80000003h
    CPUID
    mov[edi+16], eax
    mov[edi+20], ebx
    mov[edi+24], ecx
    mov[edi+28], edx
    mov eax,80000004h
    CPUID
    mov[edi+32], eax
    mov[edi+36], ebx
    mov[edi+40], ecx
    mov[edi+44], edx
    mov ecx, 0
    mov[edi+48], ecx
    jmp nomore
   intel:
    mov eax,80000000h
    CPUID
    cmp eax,80000004h
    jc nomore                
    mov  edi, idString2
    mov eax,80000002h
    CPUID
    mov[edi],    eax
    mov[edi+4],  ebx
    mov[edi+8],  ecx
    mov[edi+12], edx
    mov eax,80000003h
    CPUID
    mov[edi+16], eax
    mov[edi+20], ebx
    mov[edi+24], ecx
    mov[edi+28], edx
    mov eax,80000004h
    CPUID
    mov[edi+32], eax
    mov[edi+36], ebx
    mov[edi+40], ecx
    mov[edi+44], edx
    mov ecx, 0
    mov[edi+48], ecx
   nomore:

    pop edi
    pop edx
    pop ecx
    pop ebx
    pop eax
    ret


    global _calculateMHz   

 _calculateMHz:

        push eax
        push edx
        push ebx 
        RDTSC 
        mov [startCount], eax 
        mov ebx, 25000
  outerloop:
        mov edx, 25000
  innerloop:    
        dec     edx
        jne     innerloop
        dec     ebx
        jne     outerloop
        RDTSC
        mov     [endCount], eax
        sub     eax, [startCount]
        mov     [cycleCount], eax        
        pop ebx
        pop edx
        pop eax
        ret



    global _mips1Reg   

_mips1Reg:
      push eax
      push ebx
      push ecx
      push edx
      push edi
      mov edi, 1000000
      mov eax, [intCount1]
      align 8
  dlp:add eax, 1
      add eax, 1
      add eax, 1
      add eax, 1
      add eax, 1
      add eax, 1
      add eax, 1
      add eax, 1
      add eax, 1
      add eax, 1
      add eax, 1
      add eax, 1
      add eax, 1
      add eax, 1
      add eax, 1
      add eax, 1
      add eax, 1
      add eax, 1
      add eax, 1
      add eax, 3
      dec edi
      jnz dlp
      mov [intCount1], eax
      pop edi
      pop edx
      pop ecx
      pop ebx
      pop eax
      ret



    global _mips2Reg   

_mips2Reg:

      push eax
      push ebx
      push ecx
      push edx
      push edi
      mov edi, 1000000
      mov eax, [icount]
      mov ebx, [icount]
      align 8
  elp:add eax, 1
      add ebx, 1
      add eax, 1
      add ebx, 1
      add eax, 1
      add ebx, 1
      add eax, 1
      add ebx, 1
      add eax, 1
      add ebx, 1
      add eax, 1
      add ebx, 1
      add eax, 1
      add ebx, 1
      add eax, 1
      add ebx, 1
      add eax, 1
      add ebx, 1
      add eax, 1
      add ebx, 3
      dec edi
      jnz elp
      add eax, ebx
      mov [intCount1], eax
      pop edi
      pop edx
      pop ecx
      pop ebx
      pop eax
      ret


    global _mips3Reg   

_mips3Reg:

      push eax
      push ebx
      push ecx
      push edx
      push edi
      mov edi, 1000000
      mov eax, [intCount1]
      mov ebx, 0
      mov ecx, 0
      align 8
  flp:add eax, 1
      add ebx, 1
      add ecx, 1
      add eax, 1
      add ebx, 1
      add ecx, 1
      add eax, 1
      add ebx, 1
      add ecx, 1
      add eax, 1
      add ebx, 1
      add ecx, 1
      add eax, 1
      add ebx, 1
      add ecx, 1
      add eax, 1
      add ebx, 1
      add ecx, 1
      add eax, 1
      add ebx, 1
      add ecx, 3
      dec edi
      jnz flp
      add eax, ebx
      add eax, ecx
      mov [intCount1], eax
      pop edi
      pop edx
      pop ecx
      pop ebx
      pop eax
      ret


    global _mips4Reg   

_mips4Reg:

      push eax
      push ebx
      push ecx
      push edx
      push edi
      mov edi, 1000000
      mov eax, [icount]
      mov ebx, [icount]
      mov ecx, [icount]
      mov edx, [icount]
      align 8
  glp:add eax, 1
      add ebx, 1
      add ecx, 1
      add edx, 1
      add eax, 1
      add ebx, 1
      add ecx, 1
      add edx, 1
      add eax, 1
      add ebx, 1
      add ecx, 1
      add edx, 1
      add eax, 1
      add ebx, 1
      add ecx, 1
      add edx, 1
      add eax, 1
      add ebx, 1
      add ecx, 1
      add edx, 3
      dec edi
      jnz glp
      add eax, ebx
      add eax, ecx
      add eax, edx
      mov [intCount1], eax
      pop edi
      pop edx
      pop ecx
      pop ebx
      pop eax
      ret

    global _mflopS1Reg   
 
_mflopS1Reg:

      push edi
      mov edi, 1000000
      fld  dword [FPSCount]
      fld1 
  lf1:fadd st1, st0
      fadd st1, st0
      fadd st1, st0
      fadd st1, st0
      fadd st1, st0
      fadd st1, st0
      fadd st1, st0
      fadd st1, st0
      fadd st1, st0
      fadd st1, st0
      fadd st1, st0
      fadd st1, st0
      fadd st1, st0
      fadd st1, st0
      fadd st1, st0
      fadd st1, st0
      fadd st1, st0
      fadd st1, st0
      fadd st1, st0
      fadd st1, st0
      dec edi
      jnz lf1
      fstp dword [FPSCount]
      fstp dword [FPSCount]
      pop edi
      ret

    global _mflopS2Reg   
 
_mflopS2Reg:

      push edi
      mov edi, 1000000
      fld  dword [countS1]
      fld  dword [countS2]
      fld1
  lf2:fadd st1, st0
      fadd st2, st0
      fadd st1, st0
      fadd st2, st0
      fadd st1, st0
      fadd st2, st0
      fadd st1, st0
      fadd st2, st0
      fadd st1, st0
      fadd st2, st0
      fadd st1, st0
      fadd st2, st0
      fadd st1, st0
      fadd st2, st0
      fadd st1, st0
      fadd st2, st0
      fadd st1, st0
      fadd st2, st0
      fadd st1, st0
      fadd st2, st0
      dec edi
      jnz lf2
      fstp  dword [countS1]
      fstp  dword [countS1]
      fstp  dword [countS2]         
      pop edi
      ret

    global _mflopS3Reg   
 
_mflopS3Reg:

      push edi
      mov edi, 1000000
      fld  dword [countS1]
      fldz
      fldz 
      fld1 
  lf3:fadd st1, st0
      fadd st2, st0
      fadd st3, st0
      fadd st1, st0
      fadd st2, st0
      fadd st3, st0
      fadd st1, st0
      fadd st2, st0
      fadd st3, st0
      fadd st1, st0
      fadd st2, st0
      fadd st3, st0
      fadd st1, st0
      fadd st2, st0
      fadd st3, st0
      fadd st1, st0
      fadd st2, st0
      fadd st3, st0
      fadd st1, st0
      fadd st2, st0
      fadd st3, st0
      dec edi
      jnz lf3
      fstp  dword [countS1]
      fstp  dword [countS1]
      fstp  dword [countS2]        
      fstp  dword [countS3]        
      pop edi
      ret

    global _mflopS4Reg   
 
_mflopS4Reg:

      push edi
      mov edi, 1000000
      fld  dword [countS1]
      fld  dword [countS2]
      fld  dword [countS3]
      fld  dword [countS4]
      fld1
  lf4:fadd st1, st0
      fadd st2, st0
      fadd st3, st0
      fadd st4, st0
      fadd st1, st0
      fadd st2, st0
      fadd st3, st0
      fadd st4, st0
      fadd st1, st0
      fadd st2, st0
      fadd st3, st0
      fadd st4, st0
      fadd st1, st0
      fadd st2, st0
      fadd st3, st0
      fadd st4, st0
      fadd st1, st0
      fadd st2, st0
      fadd st3, st0
      fadd st4, st0
      dec edi
      jnz lf4
      fstp  dword [countS1]
      fstp  dword [countS1]
      fstp  dword [countS2]         
      fstp  dword [countS3]
      fstp  dword [countS4]         
      pop edi
      ret

    global _mflopD1Reg   
 
_mflopD1Reg:

      push edi
      mov edi, 1000000
      fld  qword [FPDCount]
      fld1 
  ld1:fadd st1, st0
      fadd st1, st0
      fadd st1, st0
      fadd st1, st0
      fadd st1, st0
      fadd st1, st0
      fadd st1, st0
      fadd st1, st0
      fadd st1, st0
      fadd st1, st0
      fadd st1, st0
      fadd st1, st0
      fadd st1, st0
      fadd st1, st0
      fadd st1, st0
      fadd st1, st0
      fadd st1, st0
      fadd st1, st0
      fadd st1, st0
      fadd st1, st0
      dec edi
      jnz ld1
      fstp qword [FPDCount]
      fstp qword [FPDCount]
      pop edi
      ret

    global _mflopD2Reg   
 
_mflopD2Reg:

      push edi
      mov edi, 1000000
      fld  qword [countD1]
      fld  qword [countD2]
      fld1
  ld2:fadd st1, st0
      fadd st2, st0
      fadd st1, st0
      fadd st2, st0
      fadd st1, st0
      fadd st2, st0
      fadd st1, st0
      fadd st2, st0
      fadd st1, st0
      fadd st2, st0
      fadd st1, st0
      fadd st2, st0
      fadd st1, st0
      fadd st2, st0
      fadd st1, st0
      fadd st2, st0
      fadd st1, st0
      fadd st2, st0
      fadd st1, st0
      fadd st2, st0
      dec edi
      jnz ld2
      fstp  qword [countD1]
      fstp  qword [countD1]
      fstp  qword [countD2]         
      pop edi
      ret

    global _mflopD3Reg   
 
_mflopD3Reg:

      push edi
      mov edi, 1000000
      fld  qword[countD1]
      fldz
      fldz 
      fld1 
  ld3:fadd st1, st0
      fadd st2, st0
      fadd st3, st0
      fadd st1, st0
      fadd st2, st0
      fadd st3, st0
      fadd st1, st0
      fadd st2, st0
      fadd st3, st0
      fadd st1, st0
      fadd st2, st0
      fadd st3, st0
      fadd st1, st0
      fadd st2, st0
      fadd st3, st0
      fadd st1, st0
      fadd st2, st0
      fadd st3, st0
      fadd st1, st0
      fadd st2, st0
      fadd st3, st0
      dec edi
      jnz ld3
      fstp  qword [countD1]
      fstp  qword [countD1]
      fstp  qword [countD2]         
      fstp  qword [countD3]         
      pop edi
      ret

    global _mflopD4Reg   
 
_mflopD4Reg:

      push edi
      mov edi, 1000000
      fld qword [countD1]
      fld qword [countD2]
      fld qword [countD3]
      fld qword [countD4]
      fld1
  ld4:fadd st1, st0
      fadd st2, st0
      fadd st3, st0
      fadd st4, st0
      fadd st1, st0
      fadd st2, st0
      fadd st3, st0
      fadd st4, st0
      fadd st1, st0
      fadd st2, st0
      fadd st3, st0
      fadd st4, st0
      fadd st1, st0
      fadd st2, st0
      fadd st3, st0
      fadd st4, st0
      fadd st1, st0
      fadd st2, st0
      fadd st3, st0
      fadd st4, st0
      dec edi
      jnz ld4
      fstp  qword [countD1]
      fstp  qword [countD1]
      fstp  qword [countD2]         
      fstp  qword [countD3]
      fstp  qword [countD4]         
      pop edi
      ret


    global _mmx1Reg   
 
_mmx1Reg:

    push ebx
    mov     ebx, 1000000
    movq    mm0, [mmxa]
    movq    mm1, [mmx0]
lm1:paddd   mm1, mm0
    paddd   mm1, mm0
    paddd   mm1, mm0
    paddd   mm1, mm0
    paddd   mm1, mm0
    paddd   mm1, mm0
    paddd   mm1, mm0
    paddd   mm1, mm0
    paddd   mm1, mm0
    paddd   mm1, mm0
    paddd   mm1, mm0
    paddd   mm1, mm0
    paddd   mm1, mm0
    paddd   mm1, mm0
    paddd   mm1, mm0
    paddd   mm1, mm0
    paddd   mm1, mm0
    paddd   mm1, mm0
    paddd   mm1, mm0
    paddd   mm1, mm0
    dec     ebx
    jnz     lm1
    movq    mm0, [mmxSum]
    paddd   mm1, mm0
    movq    [mmxSum], mm1
    emms
    pop ebx
    ret


    global _mmx2Reg   

_mmx2Reg:

        push ebx
        mov     ebx, 1000000
        movq    mm0, [mmxa]
        movq    mm1, [mmx0]
        movq    mm2, [mmxa]
        movq    mm3, [mmx0]
    lm2:paddd   mm1, mm0
        paddd   mm3, mm2
        paddd   mm1, mm0
        paddd   mm3, mm2
        paddd   mm1, mm0
        paddd   mm3, mm2
        paddd   mm1, mm0
        paddd   mm3, mm2
        paddd   mm1, mm0
        paddd   mm3, mm2
        paddd   mm1, mm0
        paddd   mm3, mm2
        paddd   mm1, mm0
        paddd   mm3, mm2
        paddd   mm1, mm0
        paddd   mm3, mm2
        paddd   mm1, mm0
        paddd   mm3, mm2
        paddd   mm1, mm0
        paddd   mm3, mm2
        dec     ebx
        jnz     lm2
        paddd   mm1, mm3
        movq    mm0, [mmxSum]
        paddd   mm1, mm0
        movq    [mmxSum], mm1
        emms
        pop ebx
        ret


    global _mmx3Reg   

_mmx3Reg:

        push ebx
        mov     ebx, 1000000
        movq    mm0, [mmxa]
        movq    mm1, [mmx0]
        movq    mm2, [mmxa]
        movq    mm3, [mmx0]
        movq    mm4, [mmxa]
        movq    mm5, [mmx0]
    lm3:paddd   mm1, mm0
        paddd   mm3, mm2
        paddd   mm5, mm4
        paddd   mm1, mm0
        paddd   mm3, mm2
        paddd   mm5, mm4
        paddd   mm1, mm0
        paddd   mm3, mm2
        paddd   mm5, mm4
        paddd   mm1, mm0
        paddd   mm3, mm2
        paddd   mm5, mm4
        paddd   mm1, mm0
        paddd   mm3, mm2
        paddd   mm5, mm4
        paddd   mm1, mm0
        paddd   mm3, mm2
        paddd   mm5, mm4
        paddd   mm1, mm0
        paddd   mm3, mm2
        paddd   mm5, mm4
        dec     ebx
        jnz     lm3
        paddd   mm1, mm3
        paddd   mm1, mm5
        movq    mm0, [mmxSum]
        paddd   mm1, mm0
        movq    [mmxSum], mm1
        emms
        pop ebx
        ret

    global _mmx4Reg   

_mmx4Reg:

        push ebx
        mov     ebx, 1000000
        movq    mm0, [mmxa]
        movq    mm1, [mmx0]
        movq    mm2, [mmxa]
        movq    mm3, [mmx0]
        movq    mm4, [mmxa]
        movq    mm5, [mmx0]
        movq    mm6, [mmxa]
        movq    mm7, [mmx0]
    lm4:paddd   mm1, mm0
        paddd   mm3, mm2
        paddd   mm5, mm4
        paddd   mm7, mm6
        paddd   mm1, mm0
        paddd   mm3, mm2
        paddd   mm5, mm4
        paddd   mm7, mm6
        paddd   mm1, mm0
        paddd   mm3, mm2
        paddd   mm5, mm4
        paddd   mm7, mm6
        paddd   mm1, mm0
        paddd   mm3, mm2
        paddd   mm5, mm4
        paddd   mm7, mm6
        paddd   mm1, mm0
        paddd   mm3, mm2
        paddd   mm5, mm4
        paddd   mm7, mm6
        dec     ebx
        jnz     lm4
        paddd   mm1, mm3
        paddd   mm1, mm5
        paddd   mm1, mm7
        movq    mm0, [mmxSum]
        paddd   mm1, mm0
        movq    [mmxSum], mm1
        emms
        pop ebx
        ret

    global _SSE1Reg   

_SSE1Reg:

        push ebx
        push eax
        mov     eax,  [ssum1]
        movaps  xmm0, [eax+16]
        mov     ebx,  500000
        movaps  xmm1, [eax] 
    clp:addps   xmm1, xmm0
        addps   xmm1, xmm0
        addps   xmm1, xmm0
        addps   xmm1, xmm0
        addps   xmm1, xmm0
        addps   xmm1, xmm0
        addps   xmm1, xmm0
        addps   xmm1, xmm0
        addps   xmm1, xmm0
        addps   xmm1, xmm0
        addps   xmm1, xmm0
        addps   xmm1, xmm0
        addps   xmm1, xmm0
        addps   xmm1, xmm0
        addps   xmm1, xmm0
        addps   xmm1, xmm0
        addps   xmm1, xmm0
        addps   xmm1, xmm0
        addps   xmm1, xmm0
        addps   xmm1, xmm0
        dec     ebx
        jnz     clp
        mov     ebx,  500000
        movaps  xmm2, [eax] 
    lp2:addps   xmm2, xmm0
        addps   xmm2, xmm0
        addps   xmm2, xmm0
        addps   xmm2, xmm0
        addps   xmm2, xmm0
        addps   xmm2, xmm0
        addps   xmm2, xmm0
        addps   xmm2, xmm0
        addps   xmm2, xmm0
        addps   xmm2, xmm0
        addps   xmm2, xmm0
        addps   xmm2, xmm0
        addps   xmm2, xmm0
        addps   xmm2, xmm0
        addps   xmm2, xmm0
        addps   xmm2, xmm0
        addps   xmm2, xmm0
        addps   xmm2, xmm0
        addps   xmm2, xmm0
        addps   xmm2, xmm0
        dec     ebx
        jnz     lp2
        addps   xmm1, xmm2
        movaps  [eax], xmm1
        pop eax
        pop ebx
        ret

    global _SSE2Reg   

_SSE2Reg:

        push ebx
        push eax
        mov     ebx,  1000000
        mov     eax,  [ssum1]
        movaps  xmm0, [eax+16]
        movaps  xmm1, [eax] 
        movaps  xmm2, [eax+16]
        movaps  xmm3, [eax]
     lp:addps   xmm1, xmm0
        addps   xmm3, xmm2
        addps   xmm1, xmm0
        addps   xmm3, xmm2
        addps   xmm1, xmm0
        addps   xmm3, xmm2
        addps   xmm1, xmm0
        addps   xmm3, xmm2
        addps   xmm1, xmm0
        addps   xmm3, xmm2
        addps   xmm1, xmm0
        addps   xmm3, xmm2
        addps   xmm1, xmm0
        addps   xmm3, xmm2
        addps   xmm1, xmm0
        addps   xmm3, xmm2
        addps   xmm1, xmm0
        addps   xmm3, xmm2
        addps   xmm1, xmm0
        addps   xmm3, xmm2
        dec     ebx
        jnz     lp
        addps   xmm1, xmm3
        movaps  [eax], xmm1
        pop eax
        pop ebx
        ret

    global _SSE3Reg   

_SSE3Reg:

        push ebx
        push eax
        mov     ebx,  1000000
        mov     eax,  [ssum1]
        movaps  xmm0, [eax+16]
        movaps  xmm1, [eax] 
        movaps  xmm2, [eax+16]
        movaps  xmm3, [eax]
        movaps  xmm4, [eax+16]
        movaps  xmm5, [eax]
    alp:addps   xmm1, xmm0
        addps   xmm3, xmm2
        addps   xmm5, xmm4
        addps   xmm1, xmm0
        addps   xmm3, xmm2
        addps   xmm5, xmm4
        addps   xmm1, xmm0
        addps   xmm3, xmm2
        addps   xmm5, xmm4
        addps   xmm1, xmm0
        addps   xmm3, xmm2
        addps   xmm5, xmm4
        addps   xmm1, xmm0
        addps   xmm3, xmm2
        addps   xmm5, xmm4
        addps   xmm1, xmm0
        addps   xmm3, xmm2
        addps   xmm5, xmm4
        addps   xmm1, xmm0
        addps   xmm3, xmm2
        addps   xmm5, xmm4
        dec     ebx
        jnz     alp
        addps   xmm1, xmm3
        addps   xmm1, xmm5
        movaps  [eax], xmm1
        pop eax
        pop ebx
        ret

    global _SSE4Reg   

_SSE4Reg:

        push ebx
        push eax
        mov  eax, [dsum]
        movapd    [eax], xmm6
        movapd    [eax+16], xmm7
        mov     ebx,  1000000
        mov     eax,  [ssum1]
        movaps  xmm0, [eax+16]
        movaps  xmm1, [eax] 
        movaps  xmm2, [eax+16]
        movaps  xmm3, [eax]
        movaps  xmm4, [eax+16]
        movaps  xmm5, [eax]
        movaps  xmm6, [eax+16]
        movaps  xmm7, [eax]
    blp:addps   xmm1, xmm0
        addps   xmm3, xmm2
        addps   xmm5, xmm4
        addps   xmm7, xmm6
        addps   xmm1, xmm0
        addps   xmm3, xmm2
        addps   xmm5, xmm4
        addps   xmm7, xmm6
        addps   xmm1, xmm0
        addps   xmm3, xmm2
        addps   xmm5, xmm4
        addps   xmm7, xmm6
        addps   xmm1, xmm0
        addps   xmm3, xmm2
        addps   xmm5, xmm4
        addps   xmm7, xmm6
        addps   xmm1, xmm0
        addps   xmm3, xmm2
        addps   xmm5, xmm4
        addps   xmm7, xmm6
        dec     ebx
        jnz     blp
        addps   xmm1, xmm3
        addps   xmm1, xmm5
        addps   xmm1, xmm7
        movaps  [eax], xmm1
        mov  eax, [dsum]
        movapd  xmm6, [eax]
        movapd  xmm7, [eax+16]
        pop eax
        pop ebx
        ret

  global _SSE2I1Reg   

_SSE2I1Reg:

    push ebx
    push eax
    mov     ebx, 1000000
    mov     eax,  [isum1]
    movdqa  xmm0, [eax+16]
    movdqa  xmm1, [eax]
plp:paddd   xmm1, xmm0
    paddd   xmm1, xmm0
    paddd   xmm1, xmm0
    paddd   xmm1, xmm0
    paddd   xmm1, xmm0
    paddd   xmm1, xmm0
    paddd   xmm1, xmm0
    paddd   xmm1, xmm0
    paddd   xmm1, xmm0
    paddd   xmm1, xmm0
    paddd   xmm1, xmm0
    paddd   xmm1, xmm0
    paddd   xmm1, xmm0
    paddd   xmm1, xmm0
    paddd   xmm1, xmm0
    paddd   xmm1, xmm0
    paddd   xmm1, xmm0
    paddd   xmm1, xmm0
    paddd   xmm1, xmm0
    paddd   xmm1, xmm0
    dec     ebx
    jnz     plp
    movdqa  [eax], xmm1
    pop eax
    pop ebx
    ret

    global _SSE2I2Reg   

_SSE2I2Reg:

        push ebx
        push eax
        mov     ebx, 1000000
        mov     eax,  [isum1]
        movdqa  xmm0, [eax+16]
        movdqa  xmm1, [eax]
        movdqa  xmm2, [eax+16]
        movdqa  xmm3, [eax]
    qlp:paddd   xmm1, xmm0
        paddd   xmm3, xmm2
        paddd   xmm1, xmm0
        paddd   xmm3, xmm2
        paddd   xmm1, xmm0
        paddd   xmm3, xmm2
        paddd   xmm1, xmm0
        paddd   xmm3, xmm2
        paddd   xmm1, xmm0
        paddd   xmm3, xmm2
        paddd   xmm1, xmm0
        paddd   xmm3, xmm2
        paddd   xmm1, xmm0
        paddd   xmm3, xmm2
        paddd   xmm1, xmm0
        paddd   xmm3, xmm2
        paddd   xmm1, xmm0
        paddd   xmm3, xmm2
        paddd   xmm1, xmm0
        paddd   xmm3, xmm2
        dec     ebx
        jnz     qlp
        paddd   xmm1, xmm3
        movdqa  [eax], xmm1
        pop eax
        pop ebx
        ret

    global _SSE2I3Reg   

_SSE2I3Reg:

        push ebx
        push eax
        mov     ebx, 1000000
        mov     eax,  [isum1]
        movdqa  xmm0, [eax+16]
        movdqa  xmm1, [eax]
        movdqa  xmm2, [eax+16]
        movdqa  xmm3, [eax]
        movdqa  xmm4, [eax+16]
        movdqa  xmm5, [eax]
     rlp:paddd   xmm1, xmm0
        paddd   xmm3, xmm2
        paddd   xmm5, xmm4
        paddd   xmm1, xmm0
        paddd   xmm3, xmm2
        paddd   xmm5, xmm4
        paddd   xmm1, xmm0
        paddd   xmm3, xmm2
        paddd   xmm5, xmm4
        paddd   xmm1, xmm0
        paddd   xmm3, xmm2
        paddd   xmm5, xmm4
        paddd   xmm1, xmm0
        paddd   xmm3, xmm2
        paddd   xmm5, xmm4
        paddd   xmm1, xmm0
        paddd   xmm3, xmm2
        paddd   xmm5, xmm4
        paddd   xmm1, xmm0
        paddd   xmm3, xmm2
        paddd   xmm5, xmm4
        dec     ebx
        jnz     rlp
        paddd   xmm1, xmm3
        paddd   xmm1, xmm5
        movdqa  [eax], xmm1
        pop eax
        pop ebx
        ret

    global _SSE2I4Reg   

_SSE2I4Reg:

        push ebx
        push eax
        mov  eax, [dsum]
        movapd  [eax], xmm6
        movapd  [eax+16], xmm7
        mov     ebx, 1000000
        mov     eax,  [isum1]
        movdqa  xmm0, [eax+16]
        movdqa  xmm1, [eax]
        movdqa  xmm2, [eax+16]
        movdqa  xmm3, [eax]
        movdqa  xmm4, [eax+16]
        movdqa  xmm5, [eax]
        movdqa  xmm6, [eax+16]
        movdqa  xmm7, [eax]
     slp:paddd   xmm1, xmm0
        paddd   xmm3, xmm2
        paddd   xmm5, xmm4
        paddd   xmm7, xmm6
        paddd   xmm1, xmm0
        paddd   xmm3, xmm2
        paddd   xmm5, xmm4
        paddd   xmm7, xmm6
        paddd   xmm1, xmm0
        paddd   xmm3, xmm2
        paddd   xmm5, xmm4
        paddd   xmm7, xmm6
        paddd   xmm1, xmm0
        paddd   xmm3, xmm2
        paddd   xmm5, xmm4
        paddd   xmm7, xmm6
        paddd   xmm1, xmm0
        paddd   xmm3, xmm2
        paddd   xmm5, xmm4
        paddd   xmm7, xmm6
        dec     ebx
        jnz     slp
        paddd   xmm1, xmm3
        paddd   xmm1, xmm5
        paddd   xmm1, xmm7
        movdqa  [eax], xmm1
        mov  eax, [dsum]
        movapd  xmm6, [eax]
        movapd  xmm7, [eax+16]
        pop eax
        pop ebx
        ret

    global _SSE21Reg   

_SSE21Reg:

        push ebx
        push eax
        mov     ebx,  1000000
        mov     eax,  [dsum]
        movapd  xmm0, [eax+16]
        movapd  xmm1, [eax] 
    llp:addpd   xmm1, xmm0
        addpd   xmm1, xmm0
        addpd   xmm1, xmm0
        addpd   xmm1, xmm0
        addpd   xmm1, xmm0
        addpd   xmm1, xmm0
        addpd   xmm1, xmm0
        addpd   xmm1, xmm0
        addpd   xmm1, xmm0
        addpd   xmm1, xmm0
        addpd   xmm1, xmm0
        addpd   xmm1, xmm0
        addpd   xmm1, xmm0
        addpd   xmm1, xmm0
        addpd   xmm1, xmm0
        addpd   xmm1, xmm0
        addpd   xmm1, xmm0
        addpd   xmm1, xmm0
        addpd   xmm1, xmm0
        addpd   xmm1, xmm0
        dec     ebx
        jnz     llp
        movapd  [eax], xmm1
        pop eax
        pop ebx
        ret


    global _SSE22Reg   

_SSE22Reg:

        push ebx
        push eax
        mov     ebx,  1000000
        mov     eax,  [dsum]
        movapd  xmm0, [eax+16]
        movapd  xmm1, [eax] 
        movapd  xmm2, [eax+16]
        movapd  xmm3, [eax]
    mlp:addpd   xmm1, xmm0
        addpd   xmm3, xmm2
        addpd   xmm1, xmm0
        addpd   xmm3, xmm2
        addpd   xmm1, xmm0
        addpd   xmm3, xmm2
        addpd   xmm1, xmm0
        addpd   xmm3, xmm2
        addpd   xmm1, xmm0
        addpd   xmm3, xmm2
        addpd   xmm1, xmm0
        addpd   xmm3, xmm2
        addpd   xmm1, xmm0
        addpd   xmm3, xmm2
        addpd   xmm1, xmm0
        addpd   xmm3, xmm2
        addpd   xmm1, xmm0
        addpd   xmm3, xmm2
        addpd   xmm1, xmm0
        addpd   xmm3, xmm2
        dec     ebx
        jnz     mlp
        addpd   xmm1, xmm3
        movapd  [eax], xmm1
        pop eax
        pop ebx
        ret

    global _SSE23Reg   

_SSE23Reg:

        push ebx
        push eax
        mov     ebx,  1000000
        mov     eax,  [dsum]
        movapd  xmm0, [eax+16]
        movapd  xmm1, [eax] 
        movapd  xmm2, [eax+16]
        movapd  xmm3, [eax]
        movapd  xmm4, [eax+16]
        movapd  xmm5, [eax]
     nlp:addpd   xmm1, xmm0
        addpd   xmm3, xmm2
        addpd   xmm5, xmm4
        addpd   xmm1, xmm0
        addpd   xmm3, xmm2
        addpd   xmm5, xmm4
        addpd   xmm1, xmm0
        addpd   xmm3, xmm2
        addpd   xmm5, xmm4
        addpd   xmm1, xmm0
        addpd   xmm3, xmm2
        addpd   xmm5, xmm4
        addpd   xmm1, xmm0
        addpd   xmm3, xmm2
        addpd   xmm5, xmm4
        addpd   xmm1, xmm0
        addpd   xmm3, xmm2
        addpd   xmm5, xmm4
        addpd   xmm1, xmm0
        addpd   xmm3, xmm2
        addpd   xmm5, xmm4
        dec     ebx
        jnz     nlp
        addpd   xmm1, xmm3
        addpd   xmm1, xmm5
        movapd  [eax], xmm1
        pop eax
        pop ebx
        ret

   global _SSE24Reg   

_SSE24Reg:

        push ebx
        push eax
        mov  eax, [isum1]
        movdqa  [eax], xmm6
        movdqa  [eax+16], xmm7
        mov     ebx,  1000000
        mov     eax,  [dsum]
        movapd  xmm0, [eax+16]
        movapd  xmm1, [eax] 
        movapd  xmm2, [eax+16]
        movapd  xmm3, [eax]
        movapd  xmm4, [eax+16]
        movapd  xmm5, [eax]
        movapd  xmm6, [eax+16]
        movapd  xmm7, [eax]
    olp:addpd   xmm1, xmm0
        addpd   xmm3, xmm2
        addpd   xmm5, xmm4
        addpd   xmm7, xmm6
        addpd   xmm1, xmm0
        addpd   xmm3, xmm2
        addpd   xmm5, xmm4
        addpd   xmm7, xmm6
        addpd   xmm1, xmm0
        addpd   xmm3, xmm2
        addpd   xmm5, xmm4
        addpd   xmm7, xmm6
        addpd   xmm1, xmm0
        addpd   xmm3, xmm2
        addpd   xmm5, xmm4
        addpd   xmm7, xmm6
        addpd   xmm1, xmm0
        addpd   xmm3, xmm2
        addpd   xmm5, xmm4
        addpd   xmm7, xmm6
        dec     ebx
        jnz     olp
        addpd   xmm1, xmm3
        addpd   xmm1, xmm5
        addpd   xmm1, xmm7
        movapd  [eax], xmm1
        mov  eax, [isum1]
        movdqa  xmm6, [eax]
        movdqa  xmm7, [eax+16]
        pop eax
        pop ebx
        ret

    global _SSE2I1Reg2   

_SSE2I1Reg2:

    push ebx
    push eax
    mov     ebx, 1000000
    mov     eax,  [isum1]
    movdqa  xmm0, [eax+16]
    movdqa  xmm1, [eax]
tlp:paddq   xmm1, xmm0
    paddq   xmm1, xmm0
    paddq   xmm1, xmm0
    paddq   xmm1, xmm0
    paddq   xmm1, xmm0
    paddq   xmm1, xmm0
    paddq   xmm1, xmm0
    paddq   xmm1, xmm0
    paddq   xmm1, xmm0
    paddq   xmm1, xmm0
    paddq   xmm1, xmm0
    paddq   xmm1, xmm0
    paddq   xmm1, xmm0
    paddq   xmm1, xmm0
    paddq   xmm1, xmm0
    paddq   xmm1, xmm0
    paddq   xmm1, xmm0
    paddq   xmm1, xmm0
    paddq   xmm1, xmm0
    paddq   xmm1, xmm0
    dec     ebx
    jnz     tlp
    movdqa  [eax], xmm1
    pop eax
    pop ebx
    ret

    global _SSE2I2Reg2   

_SSE2I2Reg2:

        push ebx
        push eax
        mov     ebx, 1000000
        mov     eax,  [isum1]
        movdqa  xmm0, [eax+16]
        movdqa  xmm1, [eax]
        movdqa  xmm2, [eax+16]
        movdqa  xmm3, [eax]
    ulp:paddq   xmm1, xmm0
        paddq   xmm3, xmm2
        paddq   xmm1, xmm0
        paddq   xmm3, xmm2
        paddq   xmm1, xmm0
        paddq   xmm3, xmm2
        paddq   xmm1, xmm0
        paddq   xmm3, xmm2
        paddq   xmm1, xmm0
        paddq   xmm3, xmm2
        paddq   xmm1, xmm0
        paddq   xmm3, xmm2
        paddq   xmm1, xmm0
        paddq   xmm3, xmm2
        paddq   xmm1, xmm0
        paddq   xmm3, xmm2
        paddq   xmm1, xmm0
        paddq   xmm3, xmm2
        paddq   xmm1, xmm0
        paddq   xmm3, xmm2
        dec     ebx
        jnz     ulp
        paddq   xmm1, xmm3
        movdqa  [eax], xmm1
        pop eax
        pop ebx
        ret

    global _SSE2I3Reg2   

_SSE2I3Reg2:
        push ebx
        push eax
        mov     ebx, 1000000
        mov     eax,  [isum1]
        movdqa  xmm0, [eax+16]
        movdqa  xmm1, [eax]
        movdqa  xmm2, [eax+16]
        movdqa  xmm3, [eax]
        movdqa  xmm4, [eax+16]
        movdqa  xmm5, [eax]
    vlp:paddq   xmm1, xmm0
        paddq   xmm3, xmm2
        paddq   xmm5, xmm4
        paddq   xmm1, xmm0
        paddq   xmm3, xmm2
        paddq   xmm5, xmm4
        paddq   xmm1, xmm0
        paddq   xmm3, xmm2
        paddq   xmm5, xmm4
        paddq   xmm1, xmm0
        paddq   xmm3, xmm2
        paddq   xmm5, xmm4
        paddq   xmm1, xmm0
        paddq   xmm3, xmm2
        paddq   xmm5, xmm4
        paddq   xmm1, xmm0
        paddq   xmm3, xmm2
        paddq   xmm5, xmm4
        paddq   xmm1, xmm0
        paddq   xmm3, xmm2
        paddq   xmm5, xmm4
        dec     ebx
        jnz     vlp
        paddq   xmm1, xmm3
        paddq   xmm1, xmm5
        movdqa  [eax], xmm1
        pop eax
        pop ebx
        ret

    global _SSE2I4Reg2   

_SSE2I4Reg2:

        push ebx
        push eax
        mov  eax, [dsum]
        movapd  [eax], xmm6
        movapd  [eax+16], xmm7
        mov     ebx, 1000000
        mov     eax,  [isum1]
        movdqa  xmm0, [eax+16]
        movdqa  xmm1, [eax]
        movdqa  xmm2, [eax+16]
        movdqa  xmm3, [eax]
        movdqa  xmm4, [eax+16]
        movdqa  xmm5, [eax]
        movdqa  xmm6, [eax+16]
        movdqa  xmm7, [eax]
    wlp:paddq   xmm1, xmm0
        paddq   xmm3, xmm2
        paddq   xmm5, xmm4
        paddq   xmm7, xmm6
        paddq   xmm1, xmm0
        paddq   xmm3, xmm2
        paddq   xmm5, xmm4
        paddq   xmm7, xmm6
        paddq   xmm1, xmm0
        paddq   xmm3, xmm2
        paddq   xmm5, xmm4
        paddq   xmm7, xmm6
        paddq   xmm1, xmm0
        paddq   xmm3, xmm2
        paddq   xmm5, xmm4
        paddq   xmm7, xmm6
        paddq   xmm1, xmm0
        paddq   xmm3, xmm2
        paddq   xmm5, xmm4
        paddq   xmm7, xmm6
        dec     ebx
        jnz     wlp
        paddq   xmm1, xmm3
        paddq   xmm1, xmm5
        paddq   xmm1, xmm7
        movdqa  [eax], xmm1
        mov  eax, [dsum]
        movapd  xmm6, [eax]
        movapd  xmm7, [eax+16]
        pop eax
        pop ebx
        ret

    global _Now3D1Reg   

_Now3D1Reg:

        push ebx
        push eax
        femms
        mov     eax, [ssumA]
        movq    mm0, [eax+8]
        movq    mm1, [eax] 
        mov     ebx, 500000
    lt1:pfadd   mm1, mm0
        pfadd   mm1, mm0
        pfadd   mm1, mm0
        pfadd   mm1, mm0
        pfadd   mm1, mm0
        pfadd   mm1, mm0
        pfadd   mm1, mm0
        pfadd   mm1, mm0
        pfadd   mm1, mm0
        pfadd   mm1, mm0
        pfadd   mm1, mm0
        pfadd   mm1, mm0
        pfadd   mm1, mm0
        pfadd   mm1, mm0
        pfadd   mm1, mm0
        pfadd   mm1, mm0
        pfadd   mm1, mm0
        pfadd   mm1, mm0
        pfadd   mm1, mm0
        pfadd   mm1, mm0
        dec     ebx
        jnz     lt1
        movq    mm2, [eax] 
        mov     ebx, 500000
    lu2:pfadd   mm2, mm0
        pfadd   mm2, mm0
        pfadd   mm2, mm0
        pfadd   mm2, mm0
        pfadd   mm2, mm0
        pfadd   mm2, mm0
        pfadd   mm2, mm0
        pfadd   mm2, mm0
        pfadd   mm2, mm0
        pfadd   mm2, mm0
        pfadd   mm2, mm0
        pfadd   mm2, mm0
        pfadd   mm2, mm0
        pfadd   mm2, mm0
        pfadd   mm2, mm0
        pfadd   mm2, mm0
        pfadd   mm2, mm0
        pfadd   mm2, mm0
        pfadd   mm2, mm0
        pfadd   mm2, mm0
        dec     ebx
        jnz     lu2
        pfadd   mm1, mm2
        movq    [eax], mm1
        femms
        pop eax
        pop ebx
        ret

    global _Now3D2Reg   

_Now3D2Reg:

        push ebx
        push eax
        femms
        mov     ebx, 1000000
        mov     eax, [ssumA]
        movq    mm0, [eax+8]
        movq    mm1, [eax] 
        movq    mm2, [eax+8]
        movq    mm3, [eax]
    lt2:pfadd   mm1, mm0
        pfadd   mm3, mm2
        pfadd   mm1, mm0
        pfadd   mm3, mm2
        pfadd   mm1, mm0
        pfadd   mm3, mm2
        pfadd   mm1, mm0
        pfadd   mm3, mm2
        pfadd   mm1, mm0
        pfadd   mm3, mm2
        pfadd   mm1, mm0
        pfadd   mm3, mm2
        pfadd   mm1, mm0
        pfadd   mm3, mm2
        pfadd   mm1, mm0
        pfadd   mm3, mm2
        pfadd   mm1, mm0
        pfadd   mm3, mm2
        pfadd   mm1, mm0
        pfadd   mm3, mm2
        dec     ebx
        jnz     lt2
        pfadd   mm1, mm3
        movq    [eax], mm1
        femms
        pop eax
        pop ebx
        ret

    global _Now3D3Reg   

_Now3D3Reg:

        push ebx
        push eax
        femms
        mov     ebx, 1000000
        mov     eax, [ssumA]
        movq    mm0, [eax+8]
        movq    mm1, [eax] 
        movq    mm2, [eax+8]
        movq    mm3, [eax]
        movq    mm4, [eax+8]
        movq    mm5, [eax]
    lt3:pfadd   mm1, mm0
        pfadd   mm3, mm2
        pfadd   mm5, mm4
        pfadd   mm1, mm0
        pfadd   mm3, mm2
        pfadd   mm5, mm4
        pfadd   mm1, mm0
        pfadd   mm3, mm2
        pfadd   mm5, mm4
        pfadd   mm1, mm0
        pfadd   mm3, mm2
        pfadd   mm5, mm4
        pfadd   mm1, mm0
        pfadd   mm3, mm2
        pfadd   mm5, mm4
        pfadd   mm1, mm0
        pfadd   mm3, mm2
        pfadd   mm5, mm4
        pfadd   mm1, mm0
        pfadd   mm3, mm2
        pfadd   mm5, mm4
        dec     ebx
        jnz     lt3
        pfadd   mm1, mm3
        pfadd   mm1, mm5
        movq    [eax], mm1
        femms
        pop eax
        pop ebx
        ret

    global _Now3D4Reg   

_Now3D4Reg:

        push ebx
        push eax
        femms
        mov     ebx, 1000000
        mov     eax, [ssumA]
        movq    mm0, [eax+8]
        movq    mm1, [eax] 
        movq    mm2, [eax+8]
        movq    mm3, [eax]
        movq    mm4, [eax+8]
        movq    mm5, [eax]
        movq    mm6, [eax+8]
        movq    mm7, [eax]
    lt4:pfadd   mm1, mm0
        pfadd   mm3, mm2
        pfadd   mm5, mm4
        pfadd   mm7, mm6
        pfadd   mm1, mm0
        pfadd   mm3, mm2
        pfadd   mm5, mm4
        pfadd   mm7, mm6
        pfadd   mm1, mm0
        pfadd   mm3, mm2
        pfadd   mm5, mm4
        pfadd   mm7, mm6
        pfadd   mm1, mm0
        pfadd   mm3, mm2
        pfadd   mm5, mm4
        pfadd   mm7, mm6
        pfadd   mm1, mm0
        pfadd   mm3, mm2
        pfadd   mm5, mm4
        pfadd   mm7, mm6
        dec     ebx
        jnz     lt4
        pfadd   mm1, mm3
        pfadd   mm1, mm5
        pfadd   mm1, mm7
        movq    [eax], mm1
        femms
        pop eax
        pop ebx
        ret


section .data

 extern  idString1
 extern  idString2
 extern  eaxCode1
 extern  ebxCode1
 extern  ecxCode1
 extern  edxCode1
 extern  intel1amd2
 extern  ext81edx

 extern  startCount
 extern  endCount
 extern  cycleCount

 extern intCount1
 extern icount

 extern intCounta
 extern icounta

 extern ssum1
 extern dsum

 extern isum1

 extern FPSCount
 extern countS1
 extern countS2
 extern countS3
 extern countS4
 
 extern FPDCount
 extern countD1
 extern countD2
 extern countD3
 extern countD4

 extern mmxa
 extern mmx0
 extern mmxSum
 
 extern ssumA

 
 
