section .text

    global _cpuida   

 _cpuida:

    push rax
    push rbx
    push rcx
    push rdx
    push rdi

    mov  eax, 1
    CPUID
    mov [eaxCode1], eax  ; Features Code
    mov [edxCode1], edx  ; family/model/stepping
    mov [ebxCode1], ebx
    mov [ecxCode1], ecx

    mov  rdi, idString1
    mov  eax, 0
    CPUID
    mov[rdi],   ebx
    mov[rdi+4], edx
    mov[rdi+8], ecx
    mov ecx, 0
    mov[rdi+12], ecx
    mov [intel1amd2], ebx


    ; get specials
    mov eax,80000000h
    CPUID
    cmp eax,80000000h
    jc nomore

    mov eax, [intel1amd2]
    cmp eax, 756E6547h    ; uneG
    jz intel
    cmp eax, 68747541h    ; htuA
    jnz nomore
    mov eax,80000001h
    CPUID

    mov [ext81edx], edx

    mov eax,80000000h
    CPUID
    cmp eax,80000004h
    jc nomore                
    mov  rdi, idString2
    mov eax,80000002h
    CPUID
    mov[rdi],    eax
    mov[rdi+4],  ebx
    mov[rdi+8],  ecx
    mov[rdi+12], edx
    mov eax,80000003h
    CPUID
    mov[rdi+16], eax
    mov[rdi+20], ebx
    mov[rdi+24], ecx
    mov[rdi+28], edx
    mov eax,80000004h
    CPUID
    mov[rdi+32], eax
    mov[rdi+36], ebx
    mov[rdi+40], ecx
    mov[rdi+44], edx
    mov ecx, 0
    mov[rdi+48], ecx
    jmp nomore
   intel:
    mov eax,80000000h
    CPUID
    cmp eax,80000004h
    jc nomore                
    mov  rdi, idString2
    mov eax,80000002h
    CPUID
    mov[rdi],    eax
    mov[rdi+4],  ebx
    mov[rdi+8],  ecx
    mov[rdi+12], edx
    mov eax,80000003h
    CPUID
    mov[rdi+16], eax
    mov[rdi+20], ebx
    mov[rdi+24], ecx
    mov[rdi+28], edx
    mov eax,80000004h
    CPUID
    mov[rdi+32], eax
    mov[rdi+36], ebx
    mov[rdi+40], ecx
    mov[rdi+44], edx
    mov ecx, 0
    mov[rdi+48], ecx
   nomore:

    pop rdi
    pop rdx
    pop rcx
    pop rbx
    pop rax
    ret


    global _calculateMHz   

 _calculateMHz:

        push rax
        push rdx
        push rbx 
        RDTSC 
        mov [startCount], eax 
        mov ebx, 25000
  outerloop:
        mov edx, 25000
  innerloop:    
        dec     edx
        jne     innerloop
        dec     ebx
        jne     outerloop
        RDTSC
        mov     [endCount], eax
        sub     eax, [startCount]
        mov     [cycleCount], eax        
        pop rbx
        pop rdx
        pop rax
        ret



    global _mips1Reg   

_mips1Reg:
      push rax
      push rbx
      push rcx
      push rdx
      push rdi
      mov edi, 1000000
      mov eax, [intCount1]
      align 8
  dlp:add eax, 1
      add eax, 1
      add eax, 1
      add eax, 1
      add eax, 1
      add eax, 1
      add eax, 1
      add eax, 1
      add eax, 1
      add eax, 1
      add eax, 1
      add eax, 1
      add eax, 1
      add eax, 1
      add eax, 1
      add eax, 1
      add eax, 1
      add eax, 1
      add eax, 1
      add eax, 3
      dec edi
      jnz dlp
      mov [intCount1], eax
      pop rdi
      pop rdx
      pop rcx
      pop rbx
      pop rax
      ret



    global _mips2Reg   

_mips2Reg:

      push rax
      push rbx
      push rcx
      push rdx
      push rdi
      mov edi, 1000000
      mov eax, [icount]
      mov ebx, [icount]
      align 8
  elp:add eax, 1
      add ebx, 1
      add eax, 1
      add ebx, 1
      add eax, 1
      add ebx, 1
      add eax, 1
      add ebx, 1
      add eax, 1
      add ebx, 1
      add eax, 1
      add ebx, 1
      add eax, 1
      add ebx, 1
      add eax, 1
      add ebx, 1
      add eax, 1
      add ebx, 1
      add eax, 1
      add ebx, 3
      dec edi
      jnz elp
      add eax, ebx
      mov [intCount1], eax
      pop rdi
      pop rdx
      pop rcx
      pop rbx
      pop rax
      ret


    global _mips3Reg   

_mips3Reg:

      push rax
      push rbx
      push rcx
      push rdx
      push rdi
      mov edi, 1000000
      mov eax, [intCount1]
      mov ebx, 0
      mov ecx, 0
      align 8
  flp:add eax, 1
      add ebx, 1
      add ecx, 1
      add eax, 1
      add ebx, 1
      add ecx, 1
      add eax, 1
      add ebx, 1
      add ecx, 1
      add eax, 1
      add ebx, 1
      add ecx, 1
      add eax, 1
      add ebx, 1
      add ecx, 1
      add eax, 1
      add ebx, 1
      add ecx, 1
      add eax, 1
      add ebx, 1
      add ecx, 3
      dec edi
      jnz flp
      add eax, ebx
      add eax, ecx
      mov [intCount1], eax
      pop rdi
      pop rdx
      pop rcx
      pop rbx
      pop rax
      ret


    global _mips4Reg   

_mips4Reg:

      push rax
      push rbx
      push rcx
      push rdx
      push rdi
      mov edi, 1000000
      mov eax, [icount]
      mov ebx, [icount]
      mov ecx, [icount]
      mov edx, [icount]
      align 8
  glp:add eax, 1
      add ebx, 1
      add ecx, 1
      add edx, 1
      add eax, 1
      add ebx, 1
      add ecx, 1
      add edx, 1
      add eax, 1
      add ebx, 1
      add ecx, 1
      add edx, 1
      add eax, 1
      add ebx, 1
      add ecx, 1
      add edx, 1
      add eax, 1
      add ebx, 1
      add ecx, 1
      add edx, 3
      dec edi
      jnz glp
      add eax, ebx
      add eax, ecx
      add eax, edx
      mov [intCount1], eax
      pop rdi
      pop rdx
      pop rcx
      pop rbx
      pop rax
      ret

    global _mipsa1Reg   

_mipsa1Reg:

      push rax
      push rbx
      push rcx
      push rdx
      push rdi
      mov rdi, 1000000
      mov rax, [intCounta]
      align 8
 hlp:add rax, 1
      add rax, 1
      add rax, 1
      add rax, 1
      add rax, 1
      add rax, 1
      add rax, 1
      add rax, 1
      add rax, 1
      add rax, 1
      add rax, 1
      add rax, 1
      add rax, 1
      add rax, 1
      add rax, 1
      add rax, 1
      add rax, 1
      add rax, 1
      add rax, 1
      add rax, 3
      dec rdi
      jnz hlp
      mov [intCounta], rax
      pop rdi
      pop rdx
      pop rcx
      pop rbx
      pop rax
      ret

    global _mipsa2Reg   

_mipsa2Reg:

      push rax
      push rbx
      push rcx
      push rdx
      push rdi
      mov rdi, 1000000
      mov rax, [icounta]
      mov rbx, [icounta]
      align 8
  ilp:add rax, 1
      add rbx, 1
      add rax, 1
      add rbx, 1
      add rax, 1
      add rbx, 1
      add rax, 1
      add rbx, 1
      add rax, 1
      add rbx, 1
      add rax, 1
      add rbx, 1
      add rax, 1
      add rbx, 1
      add rax, 1
      add rbx, 1
      add rax, 1
      add rbx, 1
      add rax, 1
      add rbx, 3
      dec rdi
      jnz ilp
      add rax, rbx
      mov [intCounta], rax
      pop rdi
      pop rdx
      pop rcx
      pop rbx
      pop rax
      ret

    global _mipsa3Reg   

_mipsa3Reg:

      push rax
      push rbx
      push rcx
      push rdx
      push rdi
      mov rdi, 1000000
      mov rax, [intCounta]
      mov rbx, 0
      mov rcx, 0
      align 8
  jlp:add rax, 1
      add rbx, 1
      add rcx, 1
      add rax, 1
      add rbx, 1
      add rcx, 1
      add rax, 1
      add rbx, 1
      add rcx, 1
      add rax, 1
      add rbx, 1
      add rcx, 1
      add rax, 1
      add rbx, 1
      add rcx, 1
      add rax, 1
      add rbx, 1
      add rcx, 1
      add rax, 1
      add rbx, 1
      add rcx, 3
      dec rdi
      jnz jlp
      add rax, rbx
      add rax, rcx
      mov [intCounta], rax
      pop rdi
      pop rdx
      pop rcx
      pop rbx
      pop rax
      ret

    global _mipsa4Reg   

_mipsa4Reg:

      push rax
      push rbx
      push rcx
      push rdx
      push rdi
      mov rdi, 1000000
      mov rax, [icounta]
      mov rbx, [icounta]
      mov rcx, [icounta]
      mov rdx, [icounta]
      align 8
  klp:add rax, 1
      add rbx, 1
      add rcx, 1
      add rdx, 1
      add rax, 1
      add rbx, 1
      add rcx, 1
      add rdx, 1
      add rax, 1
      add rbx, 1
      add rcx, 1
      add rdx, 1
      add rax, 1
      add rbx, 1
      add rcx, 1
      add rdx, 1
      add rax, 1
      add rbx, 1
      add rcx, 1
      add rdx, 3
      dec rdi
      jnz klp
      add rax, rbx
      add rax, rcx
      add rax, rdx
      mov [intCounta], rax
      pop rdi
      pop rdx
      pop rcx
      pop rbx
      pop rax
      ret

    global _SSE1Reg   

_SSE1Reg:

        push rbx
        push rax
        mov     eax,  [ssum1]
        movaps  xmm0, [eax+16]
        mov     ebx,  500000
        movaps  xmm1, [eax] 
    clp:addps   xmm1, xmm0
        addps   xmm1, xmm0
        addps   xmm1, xmm0
        addps   xmm1, xmm0
        addps   xmm1, xmm0
        addps   xmm1, xmm0
        addps   xmm1, xmm0
        addps   xmm1, xmm0
        addps   xmm1, xmm0
        addps   xmm1, xmm0
        addps   xmm1, xmm0
        addps   xmm1, xmm0
        addps   xmm1, xmm0
        addps   xmm1, xmm0
        addps   xmm1, xmm0
        addps   xmm1, xmm0
        addps   xmm1, xmm0
        addps   xmm1, xmm0
        addps   xmm1, xmm0
        addps   xmm1, xmm0
        dec     ebx
        jnz     clp
        mov     ebx,  500000
        movaps  xmm2, [eax] 
    lp2:addps   xmm2, xmm0
        addps   xmm2, xmm0
        addps   xmm2, xmm0
        addps   xmm2, xmm0
        addps   xmm2, xmm0
        addps   xmm2, xmm0
        addps   xmm2, xmm0
        addps   xmm2, xmm0
        addps   xmm2, xmm0
        addps   xmm2, xmm0
        addps   xmm2, xmm0
        addps   xmm2, xmm0
        addps   xmm2, xmm0
        addps   xmm2, xmm0
        addps   xmm2, xmm0
        addps   xmm2, xmm0
        addps   xmm2, xmm0
        addps   xmm2, xmm0
        addps   xmm2, xmm0
        addps   xmm2, xmm0
        dec     ebx
        jnz     lp2
        addps   xmm1, xmm2
        movaps  [eax], xmm1
        pop rax
        pop rbx
        ret
    global _SSE2Reg   

_SSE2Reg:

        push rbx
        push rax
        mov     ebx,  1000000
        mov     eax,  [ssum1]
        movaps  xmm0, [eax+16]
        movaps  xmm1, [eax] 
        movaps  xmm2, [eax+16]
        movaps  xmm3, [eax]
     lp:addps   xmm1, xmm0
        addps   xmm3, xmm2
        addps   xmm1, xmm0
        addps   xmm3, xmm2
        addps   xmm1, xmm0
        addps   xmm3, xmm2
        addps   xmm1, xmm0
        addps   xmm3, xmm2
        addps   xmm1, xmm0
        addps   xmm3, xmm2
        addps   xmm1, xmm0
        addps   xmm3, xmm2
        addps   xmm1, xmm0
        addps   xmm3, xmm2
        addps   xmm1, xmm0
        addps   xmm3, xmm2
        addps   xmm1, xmm0
        addps   xmm3, xmm2
        addps   xmm1, xmm0
        addps   xmm3, xmm2
        dec     ebx
        jnz     lp
        addps   xmm1, xmm3
        movaps  [eax], xmm1
        pop rax
        pop rbx
        ret

    global _SSE3Reg   

_SSE3Reg:

        push rbx
        push rax
        mov     ebx,  1000000
        mov     eax,  [ssum1]
        movaps  xmm0, [eax+16]
        movaps  xmm1, [eax] 
        movaps  xmm2, [eax+16]
        movaps  xmm3, [eax]
        movaps  xmm4, [eax+16]
        movaps  xmm5, [eax]
    alp:addps   xmm1, xmm0
        addps   xmm3, xmm2
        addps   xmm5, xmm4
        addps   xmm1, xmm0
        addps   xmm3, xmm2
        addps   xmm5, xmm4
        addps   xmm1, xmm0
        addps   xmm3, xmm2
        addps   xmm5, xmm4
        addps   xmm1, xmm0
        addps   xmm3, xmm2
        addps   xmm5, xmm4
        addps   xmm1, xmm0
        addps   xmm3, xmm2
        addps   xmm5, xmm4
        addps   xmm1, xmm0
        addps   xmm3, xmm2
        addps   xmm5, xmm4
        addps   xmm1, xmm0
        addps   xmm3, xmm2
        addps   xmm5, xmm4
        dec     ebx
        jnz     alp
        addps   xmm1, xmm3
        addps   xmm1, xmm5
        movaps  [eax], xmm1
        pop rax
        pop rbx
        ret

    global _SSE4Reg   

_SSE4Reg:

        push rbx
        push rax
        mov  eax, [dsum]
        movapd    [eax], xmm6
        movapd    [eax+16], xmm7
        mov     ebx,  1000000
        mov     eax,  [ssum1]
        movaps  xmm0, [eax+16]
        movaps  xmm1, [eax] 
        movaps  xmm2, [eax+16]
        movaps  xmm3, [eax]
        movaps  xmm4, [eax+16]
        movaps  xmm5, [eax]
        movaps  xmm6, [eax+16]
        movaps  xmm7, [eax]
    blp:addps   xmm1, xmm0
        addps   xmm3, xmm2
        addps   xmm5, xmm4
        addps   xmm7, xmm6
        addps   xmm1, xmm0
        addps   xmm3, xmm2
        addps   xmm5, xmm4
        addps   xmm7, xmm6
        addps   xmm1, xmm0
        addps   xmm3, xmm2
        addps   xmm5, xmm4
        addps   xmm7, xmm6
        addps   xmm1, xmm0
        addps   xmm3, xmm2
        addps   xmm5, xmm4
        addps   xmm7, xmm6
        addps   xmm1, xmm0
        addps   xmm3, xmm2
        addps   xmm5, xmm4
        addps   xmm7, xmm6
        dec     ebx
        jnz     blp
        addps   xmm1, xmm3
        addps   xmm1, xmm5
        addps   xmm1, xmm7
        movaps  [eax], xmm1
        mov  eax, [dsum]
        movapd  xmm6, [eax]
        movapd  xmm7, [eax+16]
        pop rax
        pop rbx
        ret

  global _SSE2I1Reg   

_SSE2I1Reg:

    push rbx
    push rax
    mov     ebx, 1000000
    mov     eax,  [isum1]
    movdqa  xmm0, [eax+16]
    movdqa  xmm1, [eax]
plp:paddd   xmm1, xmm0
    paddd   xmm1, xmm0
    paddd   xmm1, xmm0
    paddd   xmm1, xmm0
    paddd   xmm1, xmm0
    paddd   xmm1, xmm0
    paddd   xmm1, xmm0
    paddd   xmm1, xmm0
    paddd   xmm1, xmm0
    paddd   xmm1, xmm0
    paddd   xmm1, xmm0
    paddd   xmm1, xmm0
    paddd   xmm1, xmm0
    paddd   xmm1, xmm0
    paddd   xmm1, xmm0
    paddd   xmm1, xmm0
    paddd   xmm1, xmm0
    paddd   xmm1, xmm0
    paddd   xmm1, xmm0
    paddd   xmm1, xmm0
    dec     ebx
    jnz     plp
    movdqa  [eax], xmm1
    pop rax
    pop rbx
    ret

    global _SSE2I2Reg   

_SSE2I2Reg:

        push rbx
        push rax
        mov     ebx, 1000000
        mov     eax,  [isum1]
        movdqa  xmm0, [eax+16]
        movdqa  xmm1, [eax]
        movdqa  xmm2, [eax+16]
        movdqa  xmm3, [eax]
    qlp:paddd   xmm1, xmm0
        paddd   xmm3, xmm2
        paddd   xmm1, xmm0
        paddd   xmm3, xmm2
        paddd   xmm1, xmm0
        paddd   xmm3, xmm2
        paddd   xmm1, xmm0
        paddd   xmm3, xmm2
        paddd   xmm1, xmm0
        paddd   xmm3, xmm2
        paddd   xmm1, xmm0
        paddd   xmm3, xmm2
        paddd   xmm1, xmm0
        paddd   xmm3, xmm2
        paddd   xmm1, xmm0
        paddd   xmm3, xmm2
        paddd   xmm1, xmm0
        paddd   xmm3, xmm2
        paddd   xmm1, xmm0
        paddd   xmm3, xmm2
        dec     ebx
        jnz     qlp
        paddd   xmm1, xmm3
        movdqa  [eax], xmm1
        pop rax
        pop rbx
        ret

    global _SSE2I3Reg   

_SSE2I3Reg:

        push rbx
        push rax
        mov     ebx, 1000000
        mov     eax,  [isum1]
        movdqa  xmm0, [eax+16]
        movdqa  xmm1, [eax]
        movdqa  xmm2, [eax+16]
        movdqa  xmm3, [eax]
        movdqa  xmm4, [eax+16]
        movdqa  xmm5, [eax]
     rlp:paddd   xmm1, xmm0
        paddd   xmm3, xmm2
        paddd   xmm5, xmm4
        paddd   xmm1, xmm0
        paddd   xmm3, xmm2
        paddd   xmm5, xmm4
        paddd   xmm1, xmm0
        paddd   xmm3, xmm2
        paddd   xmm5, xmm4
        paddd   xmm1, xmm0
        paddd   xmm3, xmm2
        paddd   xmm5, xmm4
        paddd   xmm1, xmm0
        paddd   xmm3, xmm2
        paddd   xmm5, xmm4
        paddd   xmm1, xmm0
        paddd   xmm3, xmm2
        paddd   xmm5, xmm4
        paddd   xmm1, xmm0
        paddd   xmm3, xmm2
        paddd   xmm5, xmm4
        dec     ebx
        jnz     rlp
        paddd   xmm1, xmm3
        paddd   xmm1, xmm5
        movdqa  [eax], xmm1
        pop rax
        pop rbx
        ret

    global _SSE2I4Reg   

_SSE2I4Reg:

        push rbx
        push rax
        mov  eax, [dsum]
        movapd  [eax], xmm6
        movapd  [eax+16], xmm7
        mov     ebx, 1000000
        mov     eax,  [isum1]
        movdqa  xmm0, [eax+16]
        movdqa  xmm1, [eax]
        movdqa  xmm2, [eax+16]
        movdqa  xmm3, [eax]
        movdqa  xmm4, [eax+16]
        movdqa  xmm5, [eax]
        movdqa  xmm6, [eax+16]
        movdqa  xmm7, [eax]
     slp:paddd   xmm1, xmm0
        paddd   xmm3, xmm2
        paddd   xmm5, xmm4
        paddd   xmm7, xmm6
        paddd   xmm1, xmm0
        paddd   xmm3, xmm2
        paddd   xmm5, xmm4
        paddd   xmm7, xmm6
        paddd   xmm1, xmm0
        paddd   xmm3, xmm2
        paddd   xmm5, xmm4
        paddd   xmm7, xmm6
        paddd   xmm1, xmm0
        paddd   xmm3, xmm2
        paddd   xmm5, xmm4
        paddd   xmm7, xmm6
        paddd   xmm1, xmm0
        paddd   xmm3, xmm2
        paddd   xmm5, xmm4
        paddd   xmm7, xmm6
        dec     ebx
        jnz     slp
        paddd   xmm1, xmm3
        paddd   xmm1, xmm5
        paddd   xmm1, xmm7
        movdqa  [eax], xmm1
        mov  eax, [dsum]
        movapd  xmm6, [eax]
        movapd  xmm7, [eax+16]
        pop rax
        pop rbx
        ret

    global _SSE21Reg   

_SSE21Reg:

        push rbx
        push rax
        mov     ebx,  1000000
        mov     eax,  [dsum]
        movapd  xmm0, [eax+16]
        movapd  xmm1, [eax] 
    llp:addpd   xmm1, xmm0
        addpd   xmm1, xmm0
        addpd   xmm1, xmm0
        addpd   xmm1, xmm0
        addpd   xmm1, xmm0
        addpd   xmm1, xmm0
        addpd   xmm1, xmm0
        addpd   xmm1, xmm0
        addpd   xmm1, xmm0
        addpd   xmm1, xmm0
        addpd   xmm1, xmm0
        addpd   xmm1, xmm0
        addpd   xmm1, xmm0
        addpd   xmm1, xmm0
        addpd   xmm1, xmm0
        addpd   xmm1, xmm0
        addpd   xmm1, xmm0
        addpd   xmm1, xmm0
        addpd   xmm1, xmm0
        addpd   xmm1, xmm0
        dec     ebx
        jnz     llp
        movapd  [eax], xmm1
        pop rax
        pop rbx
        ret


    global _SSE22Reg   

_SSE22Reg:

        push rbx
        push rax
        mov     ebx,  1000000
        mov     eax,  [dsum]
        movapd  xmm0, [eax+16]
        movapd  xmm1, [eax] 
        movapd  xmm2, [eax+16]
        movapd  xmm3, [eax]
    mlp:addpd   xmm1, xmm0
        addpd   xmm3, xmm2
        addpd   xmm1, xmm0
        addpd   xmm3, xmm2
        addpd   xmm1, xmm0
        addpd   xmm3, xmm2
        addpd   xmm1, xmm0
        addpd   xmm3, xmm2
        addpd   xmm1, xmm0
        addpd   xmm3, xmm2
        addpd   xmm1, xmm0
        addpd   xmm3, xmm2
        addpd   xmm1, xmm0
        addpd   xmm3, xmm2
        addpd   xmm1, xmm0
        addpd   xmm3, xmm2
        addpd   xmm1, xmm0
        addpd   xmm3, xmm2
        addpd   xmm1, xmm0
        addpd   xmm3, xmm2
        dec     ebx
        jnz     mlp
        addpd   xmm1, xmm3
        movapd  [eax], xmm1
        pop rax
        pop rbx
        ret

    global _SSE23Reg   

_SSE23Reg:

        push rbx
        push rax
        mov     ebx,  1000000
        mov     eax,  [dsum]
        movapd  xmm0, [eax+16]
        movapd  xmm1, [eax] 
        movapd  xmm2, [eax+16]
        movapd  xmm3, [eax]
        movapd  xmm4, [eax+16]
        movapd  xmm5, [eax]
     nlp:addpd   xmm1, xmm0
        addpd   xmm3, xmm2
        addpd   xmm5, xmm4
        addpd   xmm1, xmm0
        addpd   xmm3, xmm2
        addpd   xmm5, xmm4
        addpd   xmm1, xmm0
        addpd   xmm3, xmm2
        addpd   xmm5, xmm4
        addpd   xmm1, xmm0
        addpd   xmm3, xmm2
        addpd   xmm5, xmm4
        addpd   xmm1, xmm0
        addpd   xmm3, xmm2
        addpd   xmm5, xmm4
        addpd   xmm1, xmm0
        addpd   xmm3, xmm2
        addpd   xmm5, xmm4
        addpd   xmm1, xmm0
        addpd   xmm3, xmm2
        addpd   xmm5, xmm4
        dec     ebx
        jnz     nlp
        addpd   xmm1, xmm3
        addpd   xmm1, xmm5
        movapd  [eax], xmm1
        pop rax
        pop rbx
        ret

   global _SSE24Reg   

_SSE24Reg:

        push rbx
        push rax
        mov  eax, [isum1]
        movdqa  [eax], xmm6
        movdqa  [eax+16], xmm7
        mov     ebx,  1000000
        mov     eax,  [dsum]
        movapd  xmm0, [eax+16]
        movapd  xmm1, [eax] 
        movapd  xmm2, [eax+16]
        movapd  xmm3, [eax]
        movapd  xmm4, [eax+16]
        movapd  xmm5, [eax]
        movapd  xmm6, [eax+16]
        movapd  xmm7, [eax]
    olp:addpd   xmm1, xmm0
        addpd   xmm3, xmm2
        addpd   xmm5, xmm4
        addpd   xmm7, xmm6
        addpd   xmm1, xmm0
        addpd   xmm3, xmm2
        addpd   xmm5, xmm4
        addpd   xmm7, xmm6
        addpd   xmm1, xmm0
        addpd   xmm3, xmm2
        addpd   xmm5, xmm4
        addpd   xmm7, xmm6
        addpd   xmm1, xmm0
        addpd   xmm3, xmm2
        addpd   xmm5, xmm4
        addpd   xmm7, xmm6
        addpd   xmm1, xmm0
        addpd   xmm3, xmm2
        addpd   xmm5, xmm4
        addpd   xmm7, xmm6
        dec     ebx
        jnz     olp
        addpd   xmm1, xmm3
        addpd   xmm1, xmm5
        addpd   xmm1, xmm7
        movapd  [eax], xmm1
        mov  eax, [isum1]
        movdqa  xmm6, [eax]
        movdqa  xmm7, [eax+16]
        pop rax
        pop rbx
        ret

    global _SSE2I1Reg2   

_SSE2I1Reg2:

    push rbx
    push rax
    mov     ebx, 1000000
    mov     eax,  [isum1]
    movdqa  xmm0, [eax+16]
    movdqa  xmm1, [eax]
tlp:paddq   xmm1, xmm0
    paddq   xmm1, xmm0
    paddq   xmm1, xmm0
    paddq   xmm1, xmm0
    paddq   xmm1, xmm0
    paddq   xmm1, xmm0
    paddq   xmm1, xmm0
    paddq   xmm1, xmm0
    paddq   xmm1, xmm0
    paddq   xmm1, xmm0
    paddq   xmm1, xmm0
    paddq   xmm1, xmm0
    paddq   xmm1, xmm0
    paddq   xmm1, xmm0
    paddq   xmm1, xmm0
    paddq   xmm1, xmm0
    paddq   xmm1, xmm0
    paddq   xmm1, xmm0
    paddq   xmm1, xmm0
    paddq   xmm1, xmm0
    dec     ebx
    jnz     tlp
    movdqa  [eax], xmm1
    pop rax
    pop rbx
    ret

    global _SSE2I2Reg2   

_SSE2I2Reg2:

        push rbx
        push rax
        mov     ebx, 1000000
        mov     eax,  [isum1]
        movdqa  xmm0, [eax+16]
        movdqa  xmm1, [eax]
        movdqa  xmm2, [eax+16]
        movdqa  xmm3, [eax]
    ulp:paddq   xmm1, xmm0
        paddq   xmm3, xmm2
        paddq   xmm1, xmm0
        paddq   xmm3, xmm2
        paddq   xmm1, xmm0
        paddq   xmm3, xmm2
        paddq   xmm1, xmm0
        paddq   xmm3, xmm2
        paddq   xmm1, xmm0
        paddq   xmm3, xmm2
        paddq   xmm1, xmm0
        paddq   xmm3, xmm2
        paddq   xmm1, xmm0
        paddq   xmm3, xmm2
        paddq   xmm1, xmm0
        paddq   xmm3, xmm2
        paddq   xmm1, xmm0
        paddq   xmm3, xmm2
        paddq   xmm1, xmm0
        paddq   xmm3, xmm2
        dec     ebx
        jnz     ulp
        paddq   xmm1, xmm3
        movdqa  [eax], xmm1
        pop rax
        pop rbx
        ret

    global _SSE2I3Reg2   

_SSE2I3Reg2:
        push rbx
        push rax
        mov     ebx, 1000000
        mov     eax,  [isum1]
        movdqa  xmm0, [eax+16]
        movdqa  xmm1, [eax]
        movdqa  xmm2, [eax+16]
        movdqa  xmm3, [eax]
        movdqa  xmm4, [eax+16]
        movdqa  xmm5, [eax]
    vlp:paddq   xmm1, xmm0
        paddq   xmm3, xmm2
        paddq   xmm5, xmm4
        paddq   xmm1, xmm0
        paddq   xmm3, xmm2
        paddq   xmm5, xmm4
        paddq   xmm1, xmm0
        paddq   xmm3, xmm2
        paddq   xmm5, xmm4
        paddq   xmm1, xmm0
        paddq   xmm3, xmm2
        paddq   xmm5, xmm4
        paddq   xmm1, xmm0
        paddq   xmm3, xmm2
        paddq   xmm5, xmm4
        paddq   xmm1, xmm0
        paddq   xmm3, xmm2
        paddq   xmm5, xmm4
        paddq   xmm1, xmm0
        paddq   xmm3, xmm2
        paddq   xmm5, xmm4
        dec     ebx
        jnz     vlp
        paddq   xmm1, xmm3
        paddq   xmm1, xmm5
        movdqa  [eax], xmm1
        pop rax
        pop rbx
        ret

    global _SSE2I4Reg2   

_SSE2I4Reg2:

        push rbx
        push rax
        mov  eax, [dsum]
        movapd  [eax], xmm6
        movapd  [eax+16], xmm7
        mov     ebx, 1000000
        mov     eax,  [isum1]
        movdqa  xmm0, [eax+16]
        movdqa  xmm1, [eax]
        movdqa  xmm2, [eax+16]
        movdqa  xmm3, [eax]
        movdqa  xmm4, [eax+16]
        movdqa  xmm5, [eax]
        movdqa  xmm6, [eax+16]
        movdqa  xmm7, [eax]
    wlp:paddq   xmm1, xmm0
        paddq   xmm3, xmm2
        paddq   xmm5, xmm4
        paddq   xmm7, xmm6
        paddq   xmm1, xmm0
        paddq   xmm3, xmm2
        paddq   xmm5, xmm4
        paddq   xmm7, xmm6
        paddq   xmm1, xmm0
        paddq   xmm3, xmm2
        paddq   xmm5, xmm4
        paddq   xmm7, xmm6
        paddq   xmm1, xmm0
        paddq   xmm3, xmm2
        paddq   xmm5, xmm4
        paddq   xmm7, xmm6
        paddq   xmm1, xmm0
        paddq   xmm3, xmm2
        paddq   xmm5, xmm4
        paddq   xmm7, xmm6
        dec     ebx
        jnz     wlp
        paddq   xmm1, xmm3
        paddq   xmm1, xmm5
        paddq   xmm1, xmm7
        movdqa  [eax], xmm1
        mov  eax, [dsum]
        movapd  xmm6, [eax]
        movapd  xmm7, [eax+16]
        pop rax
        pop rbx
        ret

section .data

 extern  idString1
 extern  idString2
 extern  eaxCode1
 extern  ebxCode1
 extern  ecxCode1
 extern  edxCode1
 extern  intel1amd2
 extern  ext81edx

 extern  startCount
 extern  endCount
 extern  cycleCount

 extern intCount1
 extern icount

 extern intCounta
 extern icounta

 extern ssum1
 extern dsum

 extern isum1


