/*
;  nasm -f elf64 -g -F stabs asscode64.asm   for asscode64.o
;  nasm -f elf  asscode32.asm                for asscode32.o
;  wrong MHz when separate asm
;  gcc whatcpu32_64.c cpuidc.c asscode64.o -m64 -lc -lm -lrt -o whatcpu64 
;  gcc whatcpu32_64.c cpuidc.c asscode32.o -lc -lm -lrt -o whatcpu32 
;  ./whatcpu64
*/

  #include <stdio.h> 
  #include "cpuidh.h"
  #include <stdlib.h> 
  #include <unistd.h>   
  #include <math.h>
  #include <inttypes.h>
  #include <stdint.h>
  #include <malloc.h>
  #include <mm_malloc.h>

  #define Bits64
//  #define Bits32

  #ifdef Bits64
  #define version  "64 bit Version 1.0"
  #else
  #define version  "32 bit Version 1.0"
  #endif


 unsigned int intCount1 = 0;
 unsigned int icount;
 unsigned int count = 0;
 unsigned int  totalI1  = 22000000;
 unsigned int  totalI2  = 23000000;

 long long  intCounta;
 long long  icounta;
 long long  counta;
 long long  totalI1a = 22000000;
 long long  totalI2a = 23000000;

 double * dsum;
 float  * ssum1;
 float  * ssumA;
 int    * isum1;

 double        MMXcount;
 double        SSEcount;
 double        SSE2count;
 double        SSE2icount;
 double        SSE2icount2;
 double        Now3Dcount;
 
 float         FPSCount = 0;
 float         countS1;
 float         countS2;
 float         countS3;
 float         countS4;

 double        FPDCount = 0;
 double        countD1;
 double        countD2;
 double        countD3;
 double        countD4;

 int           mmxSum[2];

 long long   mmxa; 
 long long   mmx0; 

int main()
{
    FILE *outfile;

    int  i, g, max, mips, mflops;


    int  mipsReg[4];
    int  mipsaReg[4];
    int  SSEmflops[4];
    int  SSE2mflops[4];
    int  SSE2mips[4];
    int  SSE2mips2[4];

    int  mflopsSP[4];
    int  mflopsDP[4];
    int  mmxMipsReg[4];
    int  Now3Dmflops[4];

    double         countS;
    double         countD;
    double         totalSP1   = 20000000;
    double         totalSP2   = 21000000;
    double         totalD1    = 20000000;
    double         totalD2    = 21000000;
    double         totalM1    = 20000000;
    double         totalM2    = 21000000;
    double         totalS21   = 40000000;
    double         totalS22   = 42000000;
    double         totalA1    = 40000000;
    double         totalA2    = 42000000;
    double         totalS1    = 80000000;
    double         totalS2    = 84000000;
    double         totalS2i1  = 80000000;
    double         totalS2i2  = 84000000;
    double         totalS2i12  = 40000000;
    double         totalS2i22  = 42000000;

    MMXcount = 0;
    SSEcount = 0;
    SSE2count = 0;
    SSE2icount = 0;
    SSE2icount2 = 0;
    Now3Dcount  = 0;
    mmxa = 0x0000000100000001;  //  4294967297;
    mmx0 = 0;
      
    outfile = fopen("CPUInfo.txt","a+");
    if (outfile == NULL)
    {
       printf(" Cannot open log file\n");
       printf(" Press Enter\n");
       g  = getchar();
       exit(1);
     }


    isum1 = (int *)_mm_malloc(64, 16);
    if (isum1 == NULL)
    {
       printf(" ERROR WILL EXIT\n");
       printf(" Press Enter\n");
       g  = getchar();
       exit(1);
    }
 
    ssum1 = (float *)_mm_malloc(64, 16);
    if (ssum1 == NULL)
    {
       printf(" ERROR WILL EXIT\n");
       printf(" Press Enter\n");
        _mm_free(isum1);
       g  = getchar();
       exit(1);
    }

    ssumA = (float *)_mm_malloc(64, 16);
    if (ssumA == NULL)
    {
       printf(" ERROR WILL EXIT\n");
       printf(" Press Enter\n");
        _mm_free(ssum1);
        _mm_free(isum1);
       g  = getchar();
       exit(1);
    }

    dsum = (double *)_mm_malloc(64, 16);
    if (dsum == NULL)
    {
       printf(" ERROR WILL EXIT\n");
       printf(" Press Enter\n");
       _mm_free(ssumA);
       _mm_free(ssum1);
       _mm_free(isum1);
       g  = getchar();
       exit(1);
    }

    printf("\n\n");

    local_time();
    printf("\n  %s", timeday);

    getDetails();
    printf("\n");
    for (i=1; i<10; i++)
    {
        printf("%s\n", configdata[i]);
    }
    printf("\n");
    fprintf (outfile, "\n"); 
    fprintf (outfile, "##############################################\n\n");
    for (i=1; i<10; i++)
    {
        fprintf(outfile, "%s \n", configdata[i]);
    }
    fprintf (outfile, "\n");
    fprintf (outfile, "##############################################\n\n");
    fprintf (outfile, "   CPU ID and Speed Test %s %s \n", version, timeday);
    fprintf(outfile, " Speeds adding to     1 Register  2 Registers  3 Registers  4 Registers\n\n");

   max = 0;
   for (i=0; i<10; i++)
   {
       count = intCount1;
       start_time();
       _mips1Reg();
       end_time();
       count = intCount1 - count;       
       mips = (int)((double)count / 1000000.0 / secs + 0.5);
       if(mips > max) max = mips;
   }       
   mipsReg[0] = max;
   printf(" 1 Register  %7d 32 Bit Integer MIPS\n", mipsReg[0]);


   max = 0;
   for (i=0; i<10; i++)
   {
       count = intCount1;
       start_time();
       icount = intCount1 / 2;
       _mips2Reg();
       end_time();
       count = intCount1 - count;       
       mips = (int)((double)count / 1000000.0 / secs + 0.5);
       if(mips > max) max = mips;
   }
   mipsReg[1] = max;
   printf(" 2 Registers %7d 32 Bit Integer MIPS\n", mipsReg[1]);

   max = 0;
   for (i=0; i<10; i++)
   {
       count = intCount1;
       start_time();
       _mips3Reg();
       end_time();
       count = intCount1 - count;       
       mips = (int)((double)count / 1000000.0 / secs + 0.5);
       if(mips > max) max = mips;
   }
   mipsReg[2] = max;
   printf(" 3 Registers %7d 32 Bit Integer MIPS\n", mipsReg[2]);
   
   max = 0;
   for (i=0; i<10; i++)
   {
       count = intCount1;
       start_time();
       icount = intCount1 / 4;
       _mips4Reg();
       end_time();
       count = intCount1 - count;      
       mips = (int)((double)count / 1000000.0 / secs + 0.5);
       if(mips > max) max = mips;
   }
   mipsReg[3] = max;
   printf(" 4 Registers %7d 32 Bit Integer MIPS\n", mipsReg[3]);
   fprintf(outfile, " 32 bit Integer MIPS %8d %12d %12d %12d\n",
                                        mipsReg[0], mipsReg[1], mipsReg[2], mipsReg[3]);
   if(intCount1 != (totalI1 * 3 + totalI2) * 10)
   { 
      fprintf(outfile, " 32 bit Integer MIPS ERRORS INCORRECT ADDITIONS\n");
      printf(" 32 bit Integer MIPS ERRORS INCORRECT ADDITIONS\n");
   }
   printf("\n");

#ifdef Bits32
   mflopsSP[0] = 0;
   mflopsSP[1] = 0;
   mflopsSP[2] = 0;
   mflopsSP[3] = 0;

   max = 0;
   for (i=0; i<10; i++)
   {
       countS = FPSCount;
       start_time();
       _mflopS1Reg();       
       end_time();
       countS = FPSCount - countS;
       mflops = (int)(countS / 1000000.0 / secs + 0.5);
       if(mflops > max) max = mflops;
   }
   mflopsSP[0] = max;
   printf(" 1 Register  %7d 32 Bit x87 MFLOPS\n", mflopsSP[0]);

   max = 0;
   for (i=0; i<10; i++)
   {
       countS = FPSCount;
       start_time();
       countS1 = FPSCount / 2;
       countS2 = FPSCount / 2;
       _mflopS2Reg();
       FPSCount = countS1 + countS2;      
       end_time();
       countS = FPSCount - countS;
       mflops = (int)(countS / 1000000.0 / secs + 0.5);
       if(mflops > max) max = mflops;
   }
   mflopsSP[1] = max;
   printf(" 2 Registers %7d 32 Bit x87 MFLOPS\n", mflopsSP[1]);

   max = 0;
   for (i=0; i<10; i++)
   {
       countS = FPSCount;
       start_time();
       countS1 = FPSCount;
       countS2 = 0.0;
       countS3 = 0.0;
       _mflopS3Reg();
       FPSCount = countS1+countS2+countS3;      
       end_time();
       countS = FPSCount - countS;
       mflops = (int)(countS / 1000000.0 / secs + 0.5);
       if(mflops > max) max = mflops;
   }
   mflopsSP[2] = max;
   printf(" 3 Registers %7d 32 Bit x87 MFLOPS\n", mflopsSP[2]);

   max = 0;
   for (i=0; i<10; i++)
   {
       countS = FPSCount;
       start_time();
       countS1 = FPSCount / 4;
       countS2 = FPSCount / 4;
       countS3 = FPSCount / 4;
       countS4 = FPSCount / 4;

       _mflopS4Reg();
       FPSCount = countS1+countS2+countS3+countS4;       
       end_time();
       countS = FPSCount - countS;
       mflops = (int)(countS / 1000000.0 / secs + 0.5);
       if(mflops > max) max = mflops;
   }
   mflopsSP[3] = max;
   printf(" 4 Registers %7d 32 Bit x87 MFLOPS\n", mflopsSP[3]);
   fprintf(outfile, " 32 bit x87 MFLOPS   %8d %12d %12d %12d\n",
                                        mflopsSP[0], mflopsSP[1], mflopsSP[2], mflopsSP[3]);
   if(FPSCount != (totalSP1 * 3 + totalSP2) * 10)
   {
      fprintf(outfile, " 32 bit x87 MFLOPS ERRORS INCORRECT ADDITIONS\n");
      printf(" 32 bit x87 MFLOPS ERRORS INCORRECT ADDITIONS\n");
   }
   printf("\n");

   mflopsDP[0] = 0;
   mflopsDP[1] = 0;
   mflopsDP[2] = 0;
   mflopsDP[3] = 0;

   max = 0;
   for (i=0; i<10; i++)
   {
       countD = FPDCount;
       start_time();
       _mflopD1Reg();       
       end_time();

       countD = FPDCount - countD;
       mflops = (int)(countD / 1000000.0 / secs + 0.5);
       if(mflops > max) max = mflops;
   }
   mflopsDP[0] = max;
   printf(" 1 Register  %7d 64 Bit x87 MFLOPS\n", mflopsDP[0]);


   max = 0;
   for (i=0; i<10; i++)
   {
       countD = FPDCount;
       start_time();
       countD1 = FPDCount / 2;
       countD2 = FPDCount / 2;
       _mflopD2Reg();
       FPDCount = countD1+countD2;       
       end_time();
       countD = FPDCount - countD;
       mflops = (int)(countD / 1000000.0 / secs + 0.5);
       if(mflops > max) max = mflops;
   }
   mflopsDP[1] = max;
   printf(" 2 Registers %7d 64 Bit x87 MFLOPS\n", mflopsDP[1]);


   max = 0;
   for (i=0; i<10; i++)
   {
       countD = FPDCount;
       start_time();
       countD1 = FPDCount;
       countD2 = 0.0;
       countD3 = 0.0;
       _mflopD3Reg();
       FPDCount = countD1+countD2+countD3;      
       end_time();
       countD = FPDCount - countD;
       mflops = (int)(countD / 1000000.0 / secs + 0.5);
       if(mflops > max) max = mflops;
   }
   mflopsDP[2] = max;
   printf(" 3 Registers %7d 64 Bit x87 MFLOPS\n", mflopsDP[2]);

   max = 0;
   for (i=0; i<10; i++)
   {
       countD = FPDCount;
       start_time();
       countD1 = FPDCount / 4;
       countD2 = FPDCount / 4;
       countD3 = FPDCount / 4;
       countD4 = FPDCount / 4;
       _mflopD4Reg();
       FPDCount = countD1+countD2+countD3+countD4;      
       end_time();
       countD = FPDCount - countD;
       mflops = (int)(countD / 1000000.0 / secs + 0.5);
       if(mflops > max) max = mflops;
   }
   mflopsDP[3] = max;
   printf(" 4 Registers %7d 64 Bit x87 MFLOPS\n", mflopsDP[3]);
   fprintf(outfile, " 64 bit x87 MFLOPS   %8d %12d %12d %12d\n",
                                        mflopsDP[0], mflopsDP[1], mflopsDP[2], mflopsDP[3]);

   if(FPDCount != (totalD1 * 3 + totalD2) * 10)
   {
      fprintf(outfile, " 64 bit x87 MFLOPS ERRORS INCORRECT ADDITIONS\n");
      printf(" 64 bit x87 MFLOPS ERRORS INCORRECT ADDITIONS\n");
   }
   printf("\n");

   if (hasMMX)
   {
       mmxMipsReg[0] = 0;
       mmxMipsReg[1] = 0;
       mmxMipsReg[2] = 0;
       mmxMipsReg[3] = 0;
       max = 0;
       for (i=0; i<10; i++)
       {    
           start_time();
           _mmx1Reg();
           end_time();
           mips = (int)(totalM1 / 1000000.0 / secs + 0.5);
           if(mips > max) max = mips;
       }
       mmxMipsReg[0] = max * 2;
       printf(" 1 Register  %7d 32 Bit MMX Int MIPS\n", mmxMipsReg[0]);
       
       max = 0;
       for (i=0; i<10; i++)
       {
           start_time();
           _mmx2Reg();
           end_time();
           mips = (int)(totalM1 / 1000000.0 / secs + 0.5);
           if(mips > max) max = mips;
       }
       mmxMipsReg[1] = max * 2;
       printf(" 2 Registers %7d 32 Bit MMX Int MIPS\n", mmxMipsReg[1]);

       max = 0;
       for (i=0; i<10; i++)
       {
           start_time();
           _mmx3Reg();
           end_time();
           mips = (int)(totalM2 / 1000000.0 / secs + 0.5);
           if(mips > max) max = mips;
       }
       mmxMipsReg[2] = max * 2;
       printf(" 3 Registers %7d 32 Bit MMX Int MIPS\n", mmxMipsReg[2]);

       max = 0;
       for (i=0; i<10; i++)
       {
           start_time();
           _mmx4Reg();
           end_time();
           mips = (int)(totalM1 / 1000000.0 / secs + 0.5);
           if(mips > max) max = mips;
       }
       mmxMipsReg[3] = max * 2;
       printf(" 4 Registers %7d 32 Bit MMX Int MIPS\n", mmxMipsReg[3]);
       MMXcount = ((double) mmxSum[0] + (double) mmxSum[1]) / 2;
       fprintf(outfile, " 32 bit MMX Int MIPS %8d %12d %12d %12d\n",
                                 mmxMipsReg[0], mmxMipsReg[1], mmxMipsReg[2], mmxMipsReg[3]);
       if(MMXcount != (totalM1 * 3 + totalM2) * 10)
       {
          fprintf(outfile, " 32 bit MMX Int MIPS ERRORS INCORRECT ADDITIONS\n");
          printf(" 32 bit MMX Int MIPS ERRORS INCORRECT ADDITIONS\n");
       }
       printf("\n");
   }
#endif

#ifdef Bits64
   max = 0;
   for (i=0; i<10; i++)
   {
       counta = intCounta;
       start_time();
       _mipsa1Reg();
       end_time();
       counta = intCounta - counta;       
       mips = (int)((double)counta / 1000000.0 / secs + 0.5);
       if(mips > max) max = mips;
   }       
   mipsaReg[0] = max;
   printf(" 1 Register  %7d 64 Bit Integer MIPS\n", mipsaReg[0]);

   max = 0;
   for (i=0; i<10; i++)
   {
       counta = intCounta;
       start_time();
       icounta = intCounta / 2;
       _mipsa2Reg();
       end_time();
       counta = intCounta - counta;       
       mips = (int)((double)counta / 1000000.0 / secs + 0.5);
       if(mips > max) max = mips;
   }
   mipsaReg[1] = max;
   printf(" 2 Registers %7d 64 Bit Integer MIPS\n", mipsaReg[1]);

   max = 0;
   for (i=0; i<10; i++)
   {
       counta = intCounta;
       start_time();
       _mipsa3Reg();
       end_time();
       counta = intCounta - counta;       
       mips = (int)((double)counta / 1000000.0 / secs + 0.5);
       if(mips > max) max = mips;
   }
   mipsaReg[2] = max;
   printf(" 3 Registers %7d 64 Bit Integer MIPS\n", mipsaReg[2]);
   
   max = 0;
   for (i=0; i<10; i++)
   {
       counta = intCounta;
       start_time();
       icounta = intCounta / 4;
       _mipsa4Reg();
       end_time();
       counta = intCounta - counta;      
       mips = (int)((double)counta / 1000000.0 / secs + 0.5);
       if(mips > max) max = mips;
   }
   mipsaReg[3] = max;
   printf(" 4 Registers %7d 64 Bit Integer MIPS\n", mipsaReg[3]);
   fprintf(outfile, " 64 bit Integer MIPS %8d %12d %12d %12d\n",
                                        mipsaReg[0], mipsaReg[1], mipsaReg[2], mipsaReg[3]);
   if(intCounta != (totalI1a * 3 + totalI2a) * 10)
   {
       fprintf(outfile, " 64 bit Integer MIPS ERRORS INCORRECT ADDITIONS\n");
       printf(" 64 bit Integer MIPS ERRORS INCORRECT ADDITIONS\n");
   }
   printf("\n");
#endif

   if (hasSSE2)
   {
       isum1[4] = 1;
       isum1[5] = 1;
       isum1[6] = 1;
       isum1[7] = 1;
       max = 0;
       for (i=0; i<10; i++)
       {    
           isum1[0] = 0;
           isum1[1] = 0;
           isum1[2] = 0;
           isum1[3] = 0;
           start_time();
           _SSE2I1Reg();
           end_time();
           mips = (int)(totalS2i1 / 1000000.0 / secs + 0.5);
           if(mips > max) max = mips;
           SSE2icount = SSE2icount + (double) isum1[0] + (double) isum1[1]
                               + (double) isum1[2] + (double) isum1[3];
       }
       SSE2mips[0] = max;
       printf(" 1 Register  %7d 32 Bit SSE2 Int MIPS\n", SSE2mips[0]);

       max = 0;
       for (i=0; i<10; i++)
       {
           isum1[0] = 0;
           isum1[1] = 0;
           isum1[2] = 0;
           isum1[3] = 0;
           start_time();
           _SSE2I2Reg();
           end_time();
           mips = (int)(totalS2i1 / 1000000.0 / secs + 0.5);
           if(mips > max) max = mips;
           SSE2icount = SSE2icount + (double) isum1[0] + (double) isum1[1]
                               + (double) isum1[2] + (double) isum1[3];
       }
       SSE2mips[1] = max;
       printf(" 2 Registers %7d 32 Bit SSE2 Int MIPS\n", SSE2mips[1]);

       max = 0;
       for (i=0; i<10; i++)
       {
           isum1[0] = 0;
           isum1[1] = 0;
           isum1[2] = 0;
           isum1[3] = 0;
           start_time();
           _SSE2I3Reg();
           end_time();
           mips = (int)(totalS2i2 / 1000000.0 / secs + 0.5);
           if(mips > max) max = mips;
           SSE2icount = SSE2icount + (double) isum1[0] + (double) isum1[1]
                               + (double) isum1[2] + (double) isum1[3];
       }
       SSE2mips[2] = max;
       printf(" 3 Registers %7d 32 Bit SSE2 Int MIPS\n", SSE2mips[2]);

       max = 0;
       for (i=0; i<10; i++)
       {
           isum1[0] = 0;
           isum1[1] = 0;
           isum1[2] = 0;
           isum1[3] = 0;
           start_time();
           _SSE2I4Reg();
           end_time();
           mips = (int)(totalS2i1 / 1000000.0 / secs + 0.5);
           if(mips > max) max = mips;
           SSE2icount = SSE2icount + (double) isum1[0] + (double) isum1[1]
                               + (double) isum1[2] + (double) isum1[3];
       }
       SSE2mips[3] = max;
       printf(" 4 Registers %7d 32 Bit SSE2 Int MIPS\n", SSE2mips[3]);
       fprintf(outfile, " 32 bit SSE2 Int MIPS%8d %12d %12d %12d\n",    
                                     SSE2mips[0], SSE2mips[1], SSE2mips[2], SSE2mips[3]);
       if(SSE2icount != (totalS2i1 * 3 + totalS2i2) * 10)
       {
           fprintf(outfile, " SSE2 32 bit MIPS ERRORS INCORRECT ADDITIONS\n");
           printf(" SSE2 32 bit MIPS ERRORS INCORRECT ADDITIONS\n");
       }
       printf("\n");
  }

   if (hasSSE2)
   {
       isum1[4] = 1;
       isum1[5] = 0;
       isum1[6] = 1;
       isum1[7] = 0;
       max = 0;
       for (i=0; i<10; i++)
       {    
           isum1[0] = 0;
           isum1[1] = 0;
           isum1[2] = 0;
           isum1[3] = 0;
           start_time();
           _SSE2I1Reg2();
           end_time();
           mips = (int)(totalS2i12 / 1000000.0 / secs + 0.5);
           if(mips > max) max = mips;
           SSE2icount2 = SSE2icount2 + (double) isum1[0] + (double) isum1[1]
                               + (double) isum1[2] + (double) isum1[3];
       }
       SSE2mips2[0] = max;
       printf(" 1 Register  %7d 64 Bit SSE2 Int MIPS\n", SSE2mips2[0]);

      max = 0;
       for (i=0; i<10; i++)
       {
           isum1[0] = 0;
           isum1[1] = 0;
           isum1[2] = 0;
           isum1[3] = 0;
           start_time();
           _SSE2I2Reg2();
           end_time();
           mips = (int)(totalS2i12 / 1000000.0 / secs + 0.5);
           if(mips > max) max = mips;
           SSE2icount2 = SSE2icount2 + (double) isum1[0] + (double) isum1[1]
                               + (double) isum1[2] + (double) isum1[3];
       }
       SSE2mips2[1] = max;
       printf(" 2 Registers %7d 64 Bit SSE2 Int MIPS\n", SSE2mips2[1]);

       max = 0;
       for (i=0; i<10; i++)
       {
           isum1[0] = 0;
           isum1[1] = 0;
           isum1[2] = 0;
           isum1[3] = 0;
           start_time();
           _SSE2I3Reg2();
           end_time();
           mips = (int)(totalS2i22 / 1000000.0 / secs + 0.5);
           if(mips > max) max = mips;
           SSE2icount2 = SSE2icount2 + (double) isum1[0] + (double) isum1[1]
                               + (double) isum1[2] + (double) isum1[3];
       }
       SSE2mips2[2] = max;
       printf(" 3 Registers %7d 64 Bit SSE2 Int MIPS\n", SSE2mips2[2]);

       max = 0;
       for (i=0; i<10; i++)
       {
           isum1[0] = 0;
           isum1[1] = 0;
           isum1[2] = 0;
           isum1[3] = 0;
           start_time();
           _SSE2I4Reg2();
           end_time();
           mips = (int)(totalS2i12 / 1000000.0 / secs + 0.5);
           if(mips > max) max = mips;
           SSE2icount2 = SSE2icount2 + (double) isum1[0] + (double) isum1[1]
                               + (double) isum1[2] + (double) isum1[3];
       }
       SSE2mips2[3] = max;
       printf(" 4 Registers %7d 64 Bit SSE2 Int MIPS\n", SSE2mips2[3]);
       fprintf(outfile, " 64 bit SSE2 Int MIPS%8d %12d %12d %12d\n",    
                                    SSE2mips2[0], SSE2mips2[1], SSE2mips2[2], SSE2mips2[3]);
       if(SSE2icount2 != (totalS2i12 * 3 + totalS2i22) * 10)
       {
            fprintf(outfile, " SSE2 64 bit MIPS ERRORS INCORRECT ADDITIONS\n");
            printf(" SSE2 64 bit MIPS ERRORS INCORRECT ADDITIONS\n");
       }
       printf("\n");
    }

   if (hasSSE)
   {
       ssum1[4] = 1;
       ssum1[5] = 1;
       ssum1[6] = 1;
       ssum1[7] = 1;
       max = 0;
       for (i=0; i<10; i++)
       {    
           ssum1[0] = 0;
           ssum1[1] = 0;
           ssum1[2] = 0;
           ssum1[3] = 0;
           start_time();
           _SSE1Reg();
           end_time();
           mflops = (int)(totalS1 / 1000000.0 / secs + 0.5);
           if(mflops > max) max = mflops;
           SSEcount = SSEcount + (double) ssum1[0] + (double) ssum1[1]
                               + (double) ssum1[2] + (double) ssum1[3];
       }
       SSEmflops[0] = max;
       printf(" 1 Register  %7d 32 Bit SSE MFLOPS\n", SSEmflops[0]);

      max = 0;
       for (i=0; i<10; i++)
       {
           ssum1[0] = 0;
           ssum1[1] = 0;
           ssum1[2] = 0;
           ssum1[3] = 0;
           start_time();
           _SSE2Reg();
           end_time();
           mflops = (int)(totalS1 / 1000000.0 / secs + 0.5);
           if(mflops > max) max = mflops;
           SSEcount = SSEcount + (double) ssum1[0] + (double) ssum1[1]
                               + (double) ssum1[2] + (double) ssum1[3];
       }
       SSEmflops[1] = max;
       printf(" 2 Registers %7d 32 Bit SSE MFLOPS\n", SSEmflops[1]);

       max = 0;
       for (i=0; i<10; i++)
       {
           ssum1[0] = 0;
           ssum1[1] = 0;
           ssum1[2] = 0;
           ssum1[3] = 0;
           start_time();
           _SSE3Reg();
           end_time();
           mflops = (int)(totalS2 / 1000000.0 / secs + 0.5);
           if(mflops > max) max = mflops;
           SSEcount = SSEcount + (double) ssum1[0] + (double) ssum1[1]
                               + (double) ssum1[2] + (double) ssum1[3];
       }
       SSEmflops[2] = max;
       printf(" 3 Registers %7d 32 Bit SSE MFLOPS\n", SSEmflops[2]);

       max = 0;
       for (i=0; i<10; i++)
       {
           ssum1[0] = 0;
           ssum1[1] = 0;
           ssum1[2] = 0;
           ssum1[3] = 0;
           start_time();
           _SSE4Reg();
           end_time();
           mflops = (int)(totalS1 / 1000000.0 / secs + 0.5);
           if(mflops > max) max = mflops;
           SSEcount = SSEcount + (double) ssum1[0] + (double) ssum1[1]
                               + (double) ssum1[2] + (double) ssum1[3];
       }
       SSEmflops[3] = max;
       printf(" 4 Registers %7d 32 Bit SSE MFLOPS\n", SSEmflops[3]);
       fprintf(outfile, " 32 bit SSE MFLOPS   %8d %12d %12d %12d\n",    
                                     SSEmflops[0], SSEmflops[1], SSEmflops[2], SSEmflops[3]);    
       if(SSEcount != (totalS1 * 3 + totalS2) * 10)
       {
           fprintf(outfile, " 32 bit SSE MFLOPS ERRORS INCORRECT ADDITIONS\n" );
           printf(" 32 bit SSE MFLOPS ERRORS INCORRECT ADDITIONS\n" );
       }
       printf("\n");
   }

   if (hasSSE2)
   {
       dsum[2] = 1;
       dsum[3] = 1;
       max = 0;
       for (i=0; i<10; i++)
       {    
           dsum[0] = 0;
           dsum[1] = 0;
           start_time();
           _SSE21Reg();
           end_time();
           mflops = (int)(totalS21 / 1000000.0 / secs + 0.5);
           if(mflops > max) max = mflops;
           SSE2count = SSE2count + dsum[0] + dsum[1];
       }
       SSE2mflops[0] = max;
       printf(" 1 Register  %7d 64 Bit SSE2 MFLOPS\n", SSE2mflops[0]);

      max = 0;
       for (i=0; i<10; i++)
       {
           dsum[0] = 0;
           dsum[1] = 0;
           start_time();
           _SSE22Reg();
           end_time();
           mflops = (int)(totalS21 / 1000000.0 / secs + 0.5);
           if(mflops > max) max = mflops;
           SSE2count = SSE2count + dsum[0] + dsum[1];
       }
       SSE2mflops[1] = max;
       printf(" 2 Registers %7d 64 Bit SSE2 MFLOPS\n", SSE2mflops[1]);

       max = 0;
       for (i=0; i<10; i++)
       {
           dsum[0] = 0;
           dsum[1] = 0;
           start_time();
           _SSE23Reg();
           end_time();
           mflops = (int)(totalS22 / 1000000.0 / secs + 0.5);
           if(mflops > max) max = mflops;
           SSE2count = SSE2count + dsum[0] + dsum[1];
       }
       SSE2mflops[2] = max;
       printf(" 3 Registers %7d 64 Bit SSE2 MFLOPS\n", SSE2mflops[2]);

       max = 0;
       for (i=0; i<10; i++)
       {
           dsum[0] = 0;
           dsum[1] = 0;
           start_time();
           _SSE24Reg();
           end_time();
           mflops = (int)(totalS21 / 1000000.0 / secs + 0.5);
           if(mflops > max) max = mflops;
           SSE2count = SSE2count + dsum[0] + dsum[1];
       }
       SSE2mflops[3] = max;
       printf(" 4 Registers %7d 64 Bit SSE2 MFLOPS\n", SSE2mflops[3]);
       fprintf(outfile, " 64 bit SSE2 MFLOPS  %8d %12d %12d %12d\n",    
                                     SSE2mflops[0], SSE2mflops[1], SSE2mflops[2], SSE2mflops[3]);    
       if(SSE2count != (totalS21 * 3 + totalS22) * 10)
       {
           fprintf(outfile, " 64 bit SSE2 MFLOPS ERRORS INCORRECT ADDITIONS\n");
           printf(" 64 bit SSE2 MFLOPS ERRORS INCORRECT ADDITIONS\n");
       }
       printf("\n");
    }

#ifdef Bits32
   if (has3DNow)
   {
       ssumA[2] = 1.0;
       ssumA[3] = 1.0;
       max = 0;
       for (i=0; i<10; i++)
       {    
           ssumA[0] = 0;
           ssumA[1] = 0;
           start_time();
           _Now3D1Reg();
           end_time();
           mflops = (int)(totalA1 / 1000000.0 / secs + 0.5);
           if(mflops > max) max = mflops;
           Now3Dcount = Now3Dcount + ((double) ssumA[0] + (double) ssumA[1]);
       }
       Now3Dmflops[0] = max;
       printf(" 1 Register  %7d 32 bit 3DNow MFLOPS\n", Now3Dmflops[0]);

       max = 0;
       for (i=0; i<10; i++)
       {
           ssumA[0] = 0;
           ssumA[1] = 0;
           start_time();
           _Now3D2Reg();
           end_time();
           mflops = (int)(totalA1 / 1000000.0 / secs + 0.5);
           if(mflops > max) max = mflops;
           Now3Dcount = Now3Dcount + ((double) ssumA[0] + (double) ssumA[1]);
       }
       Now3Dmflops[1] = max;
       printf(" 1 Registers %7d 32 bit 3DNow MFLOPS\n", Now3Dmflops[1]);

       max = 0;
       for (i=0; i<10; i++)
       {
           ssumA[0] = 0;
           ssumA[1] = 0;
           start_time();
           _Now3D3Reg();
           end_time();
           mflops = (int)(totalA2 / 1000000.0 / secs + 0.5);
           if(mflops > max) max = mflops;
           Now3Dcount = Now3Dcount + ((double) ssumA[0] + (double) ssumA[1]);
       }
       Now3Dmflops[2] = max;
       printf(" 3 Registers %7d 32 bit 3DNow MFLOPS\n", Now3Dmflops[2]);

       max = 0;
       for (i=0; i<10; i++)
       {
           ssumA[0] = 0;
           ssumA[1] = 0;
           start_time();
           _Now3D4Reg();
           end_time();
           mflops = (int)(totalA1 / 1000000.0 / secs + 0.5);
           if(mflops > max) max = mflops;
           Now3Dcount = Now3Dcount + ((double) ssumA[0] + (double) ssumA[1]);
       }
       Now3Dmflops[3] = max;
       printf(" 4 Registers %7d 32 bit 3DNow MFLOPS\n", Now3Dmflops[3]);
       fprintf(outfile, " 32 bit 3DNow MFLOPS %8d %12d %12d %12d\n",
                            Now3Dmflops[0], Now3Dmflops[1], Now3Dmflops[2], Now3Dmflops[3]);
       if(Now3Dcount != (totalA1 * 3 + totalA2) * 10)
       {
           fprintf(outfile, " 32 bit 3DNow MFLOPS ERRORS INCORRECT ADDITIONS\n");
           printf(" 32 bit 3DNow MFLOPS ERRORS INCORRECT ADDITIONS\n");
       }
       printf("\n");
   }
#endif
    fprintf(outfile, "\n");
    fclose (outfile);
    _mm_free(dsum);
    _mm_free(ssumA);
    _mm_free(ssum1);
    _mm_free(isum1);
    printf(" Results also in log file CPUInfo.txt\n\n");
    printf(" Press Enter\n");
    g  = getchar();  
 
    return 0;
}




